/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.3 $
 */
#ifndef __argtype_h__
#define __argtype_h__

/* Define ARG_* if needed */
#ifndef ARG_NONE
#define ARG_NONE	1
#endif
#ifndef ARG_STDARG
#define ARG_STDARG	2
#endif
#ifndef ARG_VARARG
#define ARG_VARARG	3
#endif

/*
 * Set ARG_TYPE if not already set
 */
#if !defined(ARG_TYPE) && defined(HAVE_STDARG_H) && defined(__STDC__)
	/* ARG_TYPE = ARG_STDARG */
#	define ARG_TYPE	ARG_STDARG
#	include <stdarg.h>
#endif
#if !defined(ARG_TYPE) && (defined(HAVE_VARARGS) || defined(HAVE_VARARGS_H))
	/* ARG_TYPE = ARG_VARARG */
#	define ARG_TYPE	ARG_VARARG
#	include <varargs.h>
#endif
/* Set to something */
#if !defined(ARG_TYPE)
	/* ARG_TYPE = ARG_NONE */
#	define ARG_TYPE	ARG_NONE
#endif

#endif	/* __argtype_h__ */
