/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.7 $
 *
 * DevData_t definetions
 */

#ifndef __mcdevdata_h__
#define __mcdevdata_h__ 

#include <sys/types.h>

/*
 * Basic device data
 *
 * Used when searching for initial list of devices
 */
typedef struct {
    char		*DevName;		/* Name of device (no unit) */
    char	       **DevAliases;		/* Dev aliases */
    int			 DevUnit;		/* Device specific unit # */
    int			 DevType;		/* If we know the DevType_t */
    char	        *DevFile;		/* Path of device file */
    int			 Slave;			/* Slave number */
    dev_t		 DevNum;		/* Device number */
    char		*CtlrName;		/* Name of Controller */
    int			 CtlrUnit;		/* Controller # */
    DevInfo_t		*CtlrDevInfo;		/* Ctlr's DevInfo ptr */
    int			 Flags;			/* DevData Device flags */
    int			 OSflags;		/* Flags passed from OS */
    int			 NodeID;		/* ID of this node */
    DevInfo_t		*OSDevInfo;		/* OS provided DevInfo */
} DevData_t;

/*
 * Flags for DevData_t.Flags
 */
#define DD_MAYBE_ALIVE	0x01			/* Device may be alive */
#define DD_IS_ALIVE	0x02			/* Device is alive */
#define DD_IS_ROOT	0x04			/* Is root dev node */

#endif	/* __mcdevdata_h__ */
