/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.6 $
 *
 * License definetions
 */

#ifndef __mclicense_h__
#define __mclicense_h__ 

/*
 * Types of licenses
 */
#define LT_FLOAT		1		/* Floating/concurrent */
#define LT_NODELOCK		2		/* Locked to 1 node */
/*
 * License Types
 * Order/value must match LT_* values
 */
#define LICENSE_TYPES		{ "", "float", "node", NULL }
#define LICENSE_DESCS		{ "", "Floating", "Node Locked", NULL }

/*
 * License class data
 */
struct _License {
    char		       *SoftName;	/* Name of software */
    char		       *SoftVer;	/* Version of software */
    int				Type;		/* One of LT_* */
    char		       *TypeStr;	/* String version of Type */
    char		       *TypeDescStr;	/* String type description */
    int				Port;		/* Port server runs on */
    char		       *File;		/* License file */
    char		       *ServerSoft;	/* Name of lic server sw */
    char		       *ServerVer;	/* License server sw ver */
    char		       *VendorServerSoft;/* Vendor server soft */
    char		       *VendorServerVer;/* Vendor server soft ver */
    int				Count;		/* # of allowed licenses */
    char		       *Issuer;		/* Who issued license */
    char		       *Hostid;		/* Hostid lic is for */
    char		       *IssueDate;	/* Date lic was issued */
    char		       *StartDate;	/* Start date */
    char		       *ExpireDate;	/* Date of expiration */
    char		       *Key;		/* License key */
    char		       *Serial;		/* Serial Number */
    struct _License	       *Next;		/* Next member */
};
typedef struct _License		License_t;

/*
 * Type for passing options to MCSI_LICENSE command.
 */
struct _LicOpts {
    int				StartPort;	/* Start port scan */
    int				EndPort;	/* End port scan */
    struct _LicOpts	       *Next;
};
typedef struct _LicOpts		LicOpts_t;

#endif	/* __mclicense_h__ */
