/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.6 $
 *
 * Network info definetions
 */

#ifndef __mcnetwork_h__
#define __mcnetwork_h__ 

#define MC_NISFIND_STATIC	1		/* Servers are static defined*/
#define MC_NISFIND_BROADCAST	2		/* Broadcast for servers */

/*
 * Types of network info (one for each of Network_t)
 */
#define MCNI_DEFGWIP		0x0001		/* DefGatewayIP */
#define MCNI_DEFGWNAME		0x0002		/* DefGatewayName */
#define MCNI_DNSDOMAIN		0x0004		/* DnsDomain */
#define MCNI_DNSSERVERIP	0x0008		/* DnsServerIPs */
#define MCNI_DNSSERVERNAME	0x0010		/* DnsServerNames */
#define MCNI_NISDOMAIN		0x0020		/* NisDomain */
#define MCNI_NISSERVERMETHOD	0x0040		/* NisServerMethod */
#define MCNI_NISSERVERIP	0x0080		/* NisServerIPs */
#define MCNI_NISSERVERNAME	0x0100		/* NisServerNames */
#define MCNI_NISSERVERCUR	0x0200		/* NisServerCurrent */
#define MCNI_NISMASTER		0x0400		/* NisMaster */
/* All MCNI_DNS* types */
#define MCNI_DNS	(MCNI_DNSDOMAIN|MCNI_DNSSERVERIP|MCNI_DNSSERVERNAME)
/* All MCNI_NIS* types */
#define MCNI_NIS	(MCNI_NISDOMAIN|MCNI_NISSERVERMETHOD|MCNI_NISSERVERIP|\
			 MCNI_NISSERVERNAME|MCNI_NISSERVERCUR|MCNI_NISMASTER)
/* All MCNI_* types */
#define MCNI_ALL	(MCNI_DEFGWIP|MCNI_DEFGWNAME|MCNI_DNSDOMAIN|\
			 MCNI_DNSSERVERIP|MCNI_DNSSERVERNAME|MCNI_NISDOMAIN|\
			 MCNI_NISSERVERMETHOD|MCNI_NISSERVERIP|\
			 MCNI_NISSERVERNAME|MCNI_NISSERVERCUR|MCNI_NISMASTER)

/*
 * These values must match MC_NISFIND_* above
 */
#define MC_NISMETHOD_STATIC	"static"
#define MC_NISMETHOD_BROADCAST	"broadcast"

/*
 * Network information type
 */
typedef struct {
    char *		DefGatewayIP;		/* Default gateway IP addr */
    char *		DefGatewayName;		/* Default gateway hostname */
    char *		DnsDomain;		/* DNS domain name */
    char **		DnsServerIPs;		/* IP addr of DNS servers */
    char **		DnsServerNames;		/* Names of DNS servers */
    char *		NisDomain;		/* NIS domainname */
    char *		NisServerMethod;	/* How servers are found */
    char **		NisServerIPs;		/* List of static servers */
    char **		NisServerNames;		/* List of static servers */
    char *		NisServerCurrent;	/* Current server */
    char *		NisMaster;		/* Name of NIS Master */
} Network_t;

#endif	/* __mcnetwork_h__ */
