/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.6 $
 *
 * SoftInfo_t definetions
 */

#ifndef __mcsoftinfo_h__
#define __mcsoftinfo_h__ 

/*
 * Software Information type.
 */
struct _SoftInfo {
    char	       *EntryType;		/* Entry Type MC_SET_*_S */
    int			EntryTypeNum;		/* Numeric EntryType */
    char	       *Name;			/* Name */
    char	       *Version;		/* Version */
    char	       *Revision;		/* Revision for this Version */
    char	       *Desc;			/* Description of software */
    char	       *DescVerbose;		/* Verbose Description */
    char	       *URL;	 		/* Product URL */
    char	       *License; 		/* Product License */
    char	       *Copyright; 		/* Product Copyright */
    char	       *Category;		/* Category pkg belongs to */
    char	       *SubCategory;		/* Sub Category */
    char	       *OSname;			/* OS name runs on */
    char	       *OSversion;		/* OS version runs on */
    char	       *Arch;			/* Architecture runs on */
    char	       *ISArch;			/* Instruct. Set Arch. */
    char	       *InstDate;		/* Installation Date */
    char	       *BuildDate;		/* Build Date */
    char	       *ProdStamp;		/* Production Stamp */
    char	       *BaseDir;		/* Base Dir for files */
    char	      **PkgDeps;		/* List of pkg dependencies */
    Large_t		DiskUsage;		/* Space used by FileList */
    SoftFileList_t     *FileList;		/* List of Files */
    Desc_t	       *DescList;		/* Misc Descriptions */
    /* Vendor's info */
    char	       *VendorName;		/* Name of vendor */
    char	       *VendorEmail;		/* Email of vendor */
    char	       *VendorPhone;		/* Phone of vendor */
    char	       *VendorStock;		/* Vendor's Stock # for Pkg */
    /* Tree Links */
    struct _SoftInfo   *Master;			/* (Up) Our parent */
    struct _SoftInfo   *Slaves;			/* (Down) Children */
    struct _SoftInfo   *Next;			/* (Side) Siblings */
};
typedef struct _SoftInfo SoftInfo_t;

/*
 * Values for SoftInfo_t.EntryType
 * Keep in sync with EntryTypes[] in softinfo.c
 */
#define MC_SET_PKG	1			/* Entry is a package */
#define MC_SET_PKG_S	"pkg"
#define MC_SET_PROD	2			/* Entry is a product */
#define MC_SET_PROD_S	"product"

#endif	/* __mcsoftinfo_h__ */
