#
# $Id: mcGeneral.pm,v 1.23 2003/04/21 20:29:22 mcooper Exp $
#
# SysInfo General class object
#

package mcGeneral;
require 5.003;

use mcMisc;
use mcDebug;

my $MyClassName = 'General';
my $PresentOrderTrack = 1;
my $Summaries;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Hostname"} = undef;
    $self->{"HostAliases"} = [];
    $self->{"HostAddrs"} = [];
    $self->{"HostId"} = undef;
    $self->{"Serial"} = undef;
    $self->{"ManShort"} = undef;
    $self->{"ManLong"} = undef;
    $self->{"Man"} = undef;
    $self->{"Model"} = undef;
    $self->{"PhysMem"} = undef;
    $self->{"VirtMem"} = undef;
    $self->{"RomVer"} = undef;
    $self->{"NumCpu"} = undef;
    $self->{"NumCpuVirt"} = undef;
    $self->{"CpuType"} = undef;
    $self->{"CpuSpeed"} = undef;
    $self->{"AppArch"} = undef;
    $self->{"KernArch"} = undef;
    $self->{"KernBits"} = undef;
    $self->{"OSname"} = undef;
    $self->{"OSver"} = undef;
    $self->{"OSdist"} = undef;
    $self->{"OSdistName"} = undef;
    $self->{"OSdistShName"} = undef;
    $self->{"OSdistVer"} = undef;
    $self->{"KernVer"} = undef;
    $self->{"BootTime"} = undef;
    $self->{"CurrentTime"} = undef;
    $self->{"LibcName"} = undef;
    $self->{"LibcVer"} = undef;
    $self->{"Entries"} = undef;
    $self->{"Members"} = undef;

    $self->{"Desc"} = undef;
    $self->{"ORDER"} = undef;

    bless ($self, $class);

    return $self;
}

sub Hostname {
    my $self = shift;

    if (!@_) {
	return $self->{"Hostname"};
    }

    $self->{"Hostname"} = shift;

    return;
}

sub HostAliases {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"HostAliases"} };
    }

    @{ $self->{"HostAliases"} } = @_;

    return;
}

sub HostAddrs {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"HostAddrs"} };
    }

    @{ $self->{"HostAddrs"} } = @_;

    return;
}

sub HostId {
    my $self = shift;

    if (!@_) {
	return $self->{"HostId"};
    }

    $self->{"HostId"} = shift;

    return;
}

sub ManShort {
    my $self = shift;

    if (!@_) {
	return $self->{"ManShort"};
    }

    $self->{"ManShort"} = shift;

    return;
}

sub ManLong {
    my $self = shift;

    if (!@_) {
	return $self->{"ManLong"};
    }

    $self->{"ManLong"} = shift;

    return;
}

sub Man {
    my $self = shift;

    if (!@_) {
	return $self->{"Man"};
    }

    $self->{"Man"} = shift;

    return;
}

sub LibcName {
    my $self = shift;

    if (!@_) {
	return $self->{"LibcName"};
    }

    $self->{"LibcName"} = shift;

    return;
}

sub LibcVer {
    my $self = shift;

    if (!@_) {
	return $self->{"LibcVer"};
    }

    $self->{"LibcVer"} = shift;

    return;
}

sub Model {
    my $self = shift;

    if (!@_) {
	return $self->{"Model"};
    }

    $self->{"Model"} = shift;

    return;
}

sub PhysMem {
    my $self = shift;

    if (!@_) {
	return $self->{"PhysMem"};
    }

    $self->{"PhysMem"} = shift;

    return;
}

sub VirtMem {
    my $self = shift;

    if (!@_) {
	return $self->{"VirtMem"};
    }

    $self->{"VirtMem"} = shift;

    return;
}

sub RomVer {
    my $self = shift;

    if (!@_) {
	return $self->{"RomVer"};
    }

    $self->{"RomVer"} = shift;

    return;
}

sub NumCpu {
    my $self = shift;

    if (!@_) {
	return $self->{"NumCpu"};
    }

    $self->{"NumCpu"} = shift;

    return;
}

sub NumCpuVirt {
    my $self = shift;

    if (!@_) {
	return $self->{"NumCpuVirt"};
    }

    $self->{"NumCpuVirt"} = shift;

    return;
}

sub CpuType {
    my $self = shift;

    if (!@_) {
	return $self->{"CpuType"};
    }

    $self->{"CpuType"} = shift;

    return;
}

sub CpuSpeed {
    my $self = shift;

    if (!@_) {
	return $self->{"CpuSpeed"};
    }

    $self->{"CpuSpeed"} = shift;

    return;
}

sub AppArch {
    my $self = shift;

    if (!@_) {
	return $self->{"AppArch"};
    }

    $self->{"AppArch"} = shift;

    return;
}

sub KernArch {
    my $self = shift;

    if (!@_) {
	return $self->{"KernArch"};
    }

    $self->{"KernArch"} = shift;

    return;
}

sub KernBits {
    my $self = shift;

    if (!@_) {
	return $self->{"KernBits"};
    }

    $self->{"KernBits"} = shift;

    return;
}

sub OSname {
    my $self = shift;

    if (!@_) {
	return $self->{"OSname"};
    }

    $self->{"OSname"} = shift;

    return;
}

sub OSver {
    my $self = shift;

    if (!@_) {
	return $self->{"OSver"};
    }

    $self->{"OSver"} = shift;

    return;
}

sub OSdist {
    my $self = shift;

    if (!@_) {
	return $self->{"OSdist"};
    }

    $self->{"OSdist"} = shift;

    return;
}

sub OSdistName {
    my $self = shift;

    if (!@_) {
	return $self->{"OSdistName"};
    }

    $self->{"OSdistName"} = shift;

    return;
}

sub OSdistShName {
    my $self = shift;

    if (!@_) {
	return $self->{"OSdistShName"};
    }

    $self->{"OSdistShName"} = shift;

    return;
}

sub OSdistVer {
    my $self = shift;

    if (!@_) {
	return $self->{"OSdistVer"};
    }

    $self->{"OSdistVer"} = shift;

    return;
}

sub KernVer {
    my $self = shift;

    if (!@_) {
	return $self->{"KernVer"};
    }

    $self->{"KernVer"} = shift;

    return;
}

sub BootTime {
    my $self = shift;

    if (!@_) {
	return $self->{"BootTime"};
    }

    $self->{"BootTime"} = shift;

    return;
}

sub CurrentTime {
    my $self = shift;

    if (!@_) {
	return $self->{"CurrentTime"};
    }

    $self->{"CurrentTime"} = shift;

    return;
}

sub Serial {
    my $self = shift;

    if (!@_) {
	return $self->{"Serial"};
    }

    $self->{"Serial"} = shift;

    return;
}

#
# Populate Members with the object Name
#
sub MembersPopulate {
    my $self = shift;
    my $Members = $self->{"Members"};
    my $SpecialMap = {
		      'arch' 		=> 'AppArch',
		      'osvers' 		=> 'OSver',
		      'cpu' 		=> 'CpuType',
		      'karch'		=> 'KernArch',
		      'memory'		=> 'PhysMem',
		     };

    foreach my $mname (keys %$Members) {
	my $Found;
	# Check the special map first
	if (my $name = $SpecialMap->{lc($mname)}) {
	    $Found = $name;
	} else {
	    # Look through all members
	    foreach my $name (keys %$self) {
		if (Eq($mname, $name)) {
		    $Found = $name;
		    last;
		}
	    }
	}
	if ($Found) {
	    $self->{"Members"}->{$mname}->Name($Found);
	} else {
	    Debug("mcGeneral->Members: Cannot identify member <%s>",
		  $mname);
	}
    }
}

#
# Set/Get mcMember info for our data members
#
sub Members {
    my $self = shift;
    my $Args = shift;
    my $HashValue = shift;

    if (!$HashValue) {
	# If we're not set yet, retrieve and set the data
	if (!$self->{"Members"}) {
	    my $sysinfo = mcSysInfo->New;
	    $sysinfo->Class($MyClassName);
	    if (!$sysinfo->RetrieveMembers($Args)) {
		# The retrieve failed
		return;
	    }
	    my $Members = $sysinfo->{$MyClassName}->Members;
	    # Copy the member info from $sysinfo to $self
	    $self->{"Members"} = $Members;
	    # Populate the Name member of each Members
	    $self->MembersPopulate;
	}
	return $self->{"Members"};
    }

    $self->{"Members"} = $HashValue;

    return;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Set/Fetch description of $Key
# If $Desc is given, then sets the description for $Key to $Desc.
# Always returns the description found.
#
sub Desc {
    my $self = shift;
    my $Key = shift;
    my $Desc = shift;

    #
    # If there is no entry as requested, try a lower case $Key
    #
    if (!exists($Descriptions->{$Key})) {
	$Key = lc($Key);
    }

##    Debug("mcGeneral->Desc: Key=<%s> Desc=<%s> Found=<%s>",
##	  $Key, $Desc, $Descriptions->{$Key}->{'Desc'});

##    if (!$Key && !$Desc && !exists($Descriptions->{$Key})) {
##	Debug("mcGeneral->Desc: Cannot locate description for <%s>", $Key);
##    }

    if ($Key && $Desc) {
	# Set description
	$Descriptions->{$Key}->{'Desc'} = $Desc;
    }

    if (exists($Descriptions->{$Key}->{'NoShow'}) &&
	$Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    # Return description
    return $Descriptions->{$Key}->{'Desc'};
}

#
# Order item is presented in
#
sub ORDER {
    my $self = shift;
    my $Key = shift;
    my $Order = shift;

    if ($Key && $Order) {
	# Set order
	$PresentOrder->{$Key} = $Order;
	return $Order;
    }

    # Return order
    return $PresentOrder->{$Key};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    my $k = $Fields[2];
    my $d = $Fields[3];
    my $v = $Fields[4];

    my $EntryName = $MyClassName;
    my $Entry = $self->New;
    # Lookup the entry (if any)
    my $e = $self->Entries($EntryName);
    if (!$e) {
	# Need a new object
	$e = $Entry;
    }

    my $key = $k;

    #
    # We set both $e and $self to make it convienent for our caller
    # to use both General->$key and General->Entries->$key
    #

    if (Eq($k, 'hostname')) {
	$e->Hostname($v);
	$self->Hostname($v);
    } elsif (Eq($k, 'hostaliases')) {
	$e->HostAliases(split(',', $v));
	$self->HostAliases(split(',', $v));
    } elsif (Eq($k, 'hostaddrs')) {
	$e->HostAddrs(split(',', $v));
	$self->HostAddrs(split(',', $v));
    } elsif (Eq($k, 'hostid')) {
	$e->HostId($v);
	$self->HostId($v);
    } elsif (Eq($k, 'serial')) {
	$e->Serial($v);
	$self->Serial($v);
    } elsif (Eq($k, 'man')) {
	$e->Man($v);
	$self->Man($v);
    } elsif (Eq($k, 'manshort')) {
	$e->ManShort($v);
	$self->ManShort($v);
    } elsif (Eq($k, 'manlong')) {
	$e->ManLong($v);
	$self->ManLong($v);
    } elsif (Eq($k, 'model')) {
	$e->Model($v);
	$self->Model($v);
    } elsif (Eq($k, 'memory')) {
	$key = 'physmem';
	$e->PhysMem($v);
	$self->PhysMem($v);
    } elsif (Eq($k, 'virtmem')) {
	$e->VirtMem($v);
	$self->VirtMem($v);
    } elsif (Eq($k, 'romver')) {
	$e->RomVer($v);
	$self->RomVer($v);
    } elsif (Eq($k, 'numcpu')) {
	$e->NumCpu($v);
	$self->NumCpu($v);
    } elsif (Eq($k, 'numcpuvirt')) {
	$e->NumCpuVirt($v);
	$self->NumCpuVirt($v);
    } elsif (Eq($k, 'cpu')) {
	$key = 'cputype';
	$e->CpuType($v);
	$self->CpuType($v);
    } elsif (Eq($k, 'cpuspeed')) {
	$e->CpuSpeed($v);
	$self->CpuSpeed($v);
    } elsif (Eq($k, 'arch')) {
	$key = 'apparch';
	$e->AppArch($v);
	$self->AppArch($v);
    } elsif (Eq($k, 'karch')) {
	$key = 'kernarch';
	$e->KernArch($v);
	$self->KernArch($v);
    } elsif (Eq($k, 'kernbits')) {
	$e->KernBits($v);
	$self->KernBits($v);
    } elsif (Eq($k, 'osname')) {
	$e->OSname($v);
	$self->OSname($v);
    } elsif (Eq($k, 'osvers')) {
	$key = 'osver';
	$e->OSver($v);
	$self->OSver($v);
    } elsif (Eq($k, 'osdistname')) {
	$e->OSdistName($v);
	$self->OSdistName($v);
    } elsif (Eq($k, 'osdistshname')) {
	$e->OSdistShName($v);
	$self->OSdistShName($v);
    } elsif (Eq($k, 'osdistver')) {
	$e->OSdistVer($v);
	$self->OSdistVer($v);
    } elsif (Eq($k, 'osdist')) {
	$e->OSdist($v);
	$self->OSdist($v);
    } elsif (Eq($k, 'kernver')) {
	$e->KernVer($v);
	$self->KernVer($v);
    } elsif (Eq($k, 'boottime')) {
	$e->BootTime($v);
	$self->BootTime($v);
    } elsif (Eq($k, 'currenttime')) {
	$e->CurrentTime($v);
	$self->CurrentTime($v);
    } elsif (Eq($k, 'libcname')) {
	$e->LibcName($v);
	$self->LibcName($v);
    } elsif (Eq($k, 'libcver')) {
	$e->LibcVer($v);
	$self->LibcVer($v);
    } else {
	Debug("General->Decode: Key <%s> is unknown.", $k);
    }

    # Set presentation order
    $self->ORDER($key, $PresentOrderTrack++);

    # Set description value for this key
    $self->Desc($key, $d);

    # Add it back
    $self->Entries({$EntryName => $e});

    return $self;
}

1; # Make require/use happy
