#
# $Id: mcGlobals.pm,v 1.3 2003/04/19 23:53:05 mcooper Exp $
#
# Global values
#

package mcGlobals;

require 5.003;
require Exporter;

sub InitVars {
    $Debug = 0;
    $SysInfoCacheDir = "/tmp";		# Cache directory
    $CacheExpireTime = 5 * 60;		# Expiration time for cache files
    $RI_MEMBERS = 'Members';		# Must match mcSysInfo->$RI_MEMBERS
    $RI_MCL = 'MagniCompLic';	
    $RI_VERSION = 'Version';
    $RI_TYPES = 'Types';		# Must match mcSysInfo->$RI_MEMBERS

    @AllClassNames = ( 'general', 'device', 'software', 'license', 'sysconf',
		       'kernel', 'partition', 'printer', 'netif', 'network' );
}

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   $Debug
		   $SysInfoCacheDir
		   $CacheExpireTime
		   @AllClassNames
		   $RI_MEMBERS
		   $RI_MCL
		   $RI_VERSION
		   $RI_TYPES
		  );

    InitVars();
}

1; # Make require/use happy
