#
# $Id: mcLicenseInfo.pm,v 1.4 2003/03/08 01:34:18 mcooper Exp $
#
# LicenseInfo object
#

package mcLicenseInfo;
require 5.003;

use mcMisc;

my $PresentOrderTrack = 1;
my $Summaries;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"SoftName"} = undef;
    $self->{"SoftVer"} = undef;
    $self->{"Type"} = undef;
    $self->{"TypeDesc"} = undef;
    $self->{"Port"} = undef;
    $self->{"File"} = undef;
    $self->{"ServerSoft"} = undef;
    $self->{"ServerVer"} = undef;
    $self->{"VendorServerSoft"} = undef;
    $self->{"VendorServerVer"} = undef;
    $self->{"Count"} = undef;
    $self->{"Issuer"} = undef;
    $self->{"Hostid"} = undef;
    $self->{"IssueDate"} = undef;
    $self->{"StartDate"} = undef;
    $self->{"ExpireDate"} = undef;
    $self->{"DaysLeft"} = undef;
    $self->{"Key"} = undef;
    $self->{"Serial"} = undef;
    $self->{"MinCPU"} = undef;
    $self->{"MaxCPU"} = undef;
    $self->{"AccountName"} = undef;
    $self->{"AccountNumber"} = undef;
    $self->{"Comment"} = undef;
    $self->{"LicenseURL"} = undef;
    $self->{"HomePageURL"} = undef;
    $self->{"Status"} = undef;
    $self->{"HostName"} = undef;

    $self->{"Desc"} = undef;
    $self->{"ORDER"} = undef;
    $self->{"SUMMARY"} = undef;

    bless ($self, $class);

    return $self;
}

sub SoftName {
    my $self = shift;

    if (!@_) {
	return $self->{"SoftName"};
    }

    $self->{"SoftName"} = shift;

    return;
}

sub SoftVer {
    my $self = shift;

    if (!@_) {
	return $self->{"SoftVer"};
    }

    $self->{"SoftVer"} = shift;

    return;
}

sub Type {
    my $self = shift;

    if (!@_) {
	return $self->{"Type"};
    }

    $self->{"Type"} = shift;

    return;
}

sub TypeDesc {
    my $self = shift;

    if (!@_) {
	return $self->{"TypeDesc"};
    }

    $self->{"TypeDesc"} = shift;

    return;
}

sub Port {
    my $self = shift;

    if (!@_) {
	return $self->{"Port"};
    }

    $self->{"Port"} = shift;

    return;
}

sub File {
    my $self = shift;

    if (!@_) {
	return $self->{"File"};
    }

    $self->{"File"} = shift;

    return;
}

sub ServerSoft {
    my $self = shift;

    if (!@_) {
	return $self->{"ServerSoft"};
    }

    $self->{"ServerSoft"} = shift;

    return;
}

sub ServerVer {
    my $self = shift;

    if (!@_) {
	return $self->{"ServerVer"};
    }

    $self->{"ServerVer"} = shift;

    return;
}

sub VendorServerSoft {
    my $self = shift;

    if (!@_) {
	return $self->{"VendorServerSoft"};
    }

    $self->{"VendorServerSoft"} = shift;

    return;
}

sub VendorServerVer {
    my $self = shift;

    if (!@_) {
	return $self->{"VendorServerVer"};
    }

    $self->{"VendorServerVer"} = shift;

    return;
}

sub Count {
    my $self = shift;

    if (!@_) {
	return $self->{"Count"};
    }

    $self->{"Count"} = shift;

    return;
}

sub Issuer {
    my $self = shift;

    if (!@_) {
	return $self->{"Issuer"};
    }

    $self->{"Issuer"} = shift;

    return;
}

sub Hostid {
    my $self = shift;

    if (!@_) {
	return $self->{"Hostid"};
    }

    $self->{"Hostid"} = shift;

    return;
}

sub IssueDate {
    my $self = shift;

    if (!@_) {
	return $self->{"IssueDate"};
    }

    $self->{"IssueDate"} = shift;

    return;
}

sub StartDate {
    my $self = shift;

    if (!@_) {
	return $self->{"StartDate"};
    }

    $self->{"StartDate"} = shift;

    return;
}

sub ExpireDate {
    my $self = shift;

    if (!@_) {
	return $self->{"ExpireDate"};
    }

    $self->{"ExpireDate"} = shift;

    return;
}

sub Serial {
    my $self = shift;

    if (!@_) {
	return $self->{"Serial"};
    }

    $self->{"Serial"} = shift;

    return;
}

sub Key {
    my $self = shift;

    if (!@_) {
	return $self->{"Key"};
    }

    $self->{"Key"} = shift;

    return;
}

sub MinCPU {
    my $self = shift;

    if (!@_) {
	return $self->{"MinCPU"};
    }

    $self->{"MinCPU"} = shift;

    return;
}

sub MaxCPU {
    my $self = shift;

    if (!@_) {
	return $self->{"MaxCPU"};
    }

    $self->{"MaxCPU"} = shift;

    return;
}

sub AccountName {
    my $self = shift;

    if (!@_) {
	return $self->{"AccountName"};
    }

    $self->{"AccountName"} = shift;

    return;
}

sub AccountNumber {
    my $self = shift;

    if (!@_) {
	return $self->{"AccountNumber"};
    }

    $self->{"AccountNumber"} = shift;

    return;
}

sub Comment {
    my $self = shift;

    if (!@_) {
	return $self->{"Comment"};
    }

    $self->{"Comment"} = shift;

    return;
}

sub LicenseURL {
    my $self = shift;

    if (!@_) {
	return $self->{"LicenseURL"};
    }

    $self->{"LicenseURL"} = shift;

    return;
}

sub HomePageURL {
    my $self = shift;

    if (!@_) {
	return $self->{"HomePageURL"};
    }

    $self->{"HomePageURL"} = shift;

    return;
}

sub DaysLeft {
    my $self = shift;

    if (!@_) {
	return $self->{"DaysLeft"};
    }

    $self->{"DaysLeft"} = shift;

    return;
}

sub Status {
    my $self = shift;

    if (!@_) {
	return $self->{"Status"};
    }

    $self->{"Status"} = shift;

    return;
}

sub HostName {
    my $self = shift;

    if (!@_) {
	return $self->{"HostName"};
    }

    $self->{"HostName"} = shift;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;
    my $Desc = shift;

    if ($Key && $Desc) {
	# Set description
	$Descriptions->{$Key}->{'Desc'} = $Desc;
	return $Desc;
    }

    if ($Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    # Return description
    return $Descriptions->{$Key}->{'Desc'};
}

#
# Fetch/set summary of this item
#
sub SUMMARY {
    my $self = shift;
    my $Desc = shift;

    if ($Desc) {
	# Set description
	$Summaries->{$self->SoftName} = $Desc;
	return $Desc;
    }

    # Return summary
    return $Summaries->{$self->SoftName};
}

#
# Order item is presented in
#
sub ORDER {
    my $self = shift;
    my $Key = shift;
    my $Order = shift;

    if ($Key && $Order) {
	# Set order
	$PresentOrder->{$Key} = $Order;
	return $Order;
    }

    # Return order
    return $PresentOrder->{$Key};
}

#
# Decode an array of license fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (Eq($Fields[1], 'name')) {
	$self->SoftName($Fields[2]);
    } elsif (Eq($Fields[1], 'prop')) {
	$self->SoftName($Fields[2]);

	my $key = $Fields[3];
	my $desc = $Fields[4];
	my $v = $Fields[5];
	my $k = $key;

	if (Eq($k, 'softver')) {
	    $self->SoftVer($v);
	} elsif (Eq($k, 'type')) {
	    $self->Type($v);
	} elsif (Eq($k, 'typedesc')) {
	    $self->TypeDesc($v);
	} elsif (Eq($k, 'port')) {
	    $self->Port($v);
	} elsif (Eq($k, 'count')) {
	    $self->Count($v);
	} elsif (Eq($k, 'file')) {
	    $self->File($v);
	} elsif (Eq($k, 'serversoft')) {
	    $self->ServerSoft($v);
	} elsif (Eq($k, 'serverver')) {
	    $self->ServerVer($v);
	} elsif (Eq($k, 'vendorserversoft')) {
	    $self->VendorServerSoft($v);
	} elsif (Eq($k, 'vendorserverver')) {
	    $self->VendorServerVer($v);
	} elsif (Eq($k, 'issuer')) {
	    $self->Issuer($v);
	} elsif (Eq($k, 'hostid')) {
	    $self->Hostid($v);
	} elsif (Eq($k, 'issuedate')) {
	    $self->IssueDate($v);
	} elsif (Eq($k, 'startdate')) {
	    $self->StartDate($v);
	} elsif (Eq($k, 'expiredate')) {
	    $self->ExpireDate($v);
	} elsif (Eq($k, 'serial')) {
	    $self->Serial($v);
	} elsif (Eq($k, 'key')) {
	    $self->Key($v);
	}

	# Set presentation order
	$self->ORDER($key, $PresentOrderTrack++);

	# Set description value for this key
	$self->Desc($key, $desc);
    }

    return $self;
}

1; # Make require/use happy
