#
# $Id: mcMember.pm,v 1.3 2003/05/07 18:08:25 mcooper Exp $
#
# SysInfo Member object.
# This object describes a member of a class object.
#

package mcMember;
require 5.003;
require Exporter;

use mcMisc;
use mcDebug;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   MemberFind
		  );
}

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Name"} = undef;		# Object member name
    $self->{"ClassName"} = undef;	# Class name we belong too
    $self->{"Key"} = undef;		# Selection keyword
    $self->{"Desc"} = undef;		# Description

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}
sub ClassName {
    my $self = shift;

    if (!@_) {
	return $self->{"ClassName"};
    }

    $self->{"ClassName"} = shift;

    return;
}
sub Key {
    my $self = shift;

    if (!@_) {
	return $self->{"Key"};
    }

    $self->{"Key"} = shift;

    return;
}
sub Desc {
    my $self = shift;

    if (!@_) {
	return $self->{"Desc"};
    }

    $self->{"Desc"} = shift;

    return;
}

#
# Decode an array of member fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[1], "member")) {
	return;
    }

    $self->ClassName($Fields[0]);
    $self->Key($Fields[2]);
    $self->Desc($Fields[3]);

    return $self;
}

#
# Find member named $Name and return its mcMember object
#
sub MemberFind {
    my $Name = shift;
    my $Members = shift;

    foreach my $key (keys %$Members) {
	my $member = $Members->{$key};
	if (Eq($member->Key, $Name) || Eq($member->Name, $Name)) {
	    return $member;
	}
    }

    return;
}

1;
