#
# $Id: mcMisc.pm,v 1.10 2003/04/16 20:24:40 mcooper Exp $
#
# Misc SysInfo functions
#

package mcMisc;
require 5.003;
require Exporter;

use mcGlobals;

my $FHnumber = 'fh0000';
$ProgramName = undef;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   $ProgramName
		   GetFH Eq Error ArrayFind
		  );
}

#
# Return a NEW file handle
#
sub GetFH {
    return ++$FHnumber;
}

#
# Compare strings regardless of case.
#
sub Eq {
    return lc($_[0]) eq lc($_[1]);
}

#
# Display an error message
#
sub Error {
    if (!$ProgramName) {
	$ProgramName = $ARGV[0];
    }
    if ($ProgramName) {
	printf STDERR "%s: ", $ProgramName;
    }
    printf STDERR @_;
    printf STDERR "\n";
}

#
# Look for $name in @array
#
sub ArrayFind {
    my $name = shift;
    my @array = @_;

    for (my $i = 0; $i <= $#array; ++$i) {
	if ($name eq $array[$i]) {
	    return $array[$i];
	}
    }

    return undef;
}

1; # Make require/use happy
