#
# $Id: mcPartInfo.pm,v 1.5 2002/07/10 16:04:00 mcooper Exp $
#
# PartInfo object
#

package mcPartInfo;
require 5.003;

use mcMisc;

my $PresentOrderTrack = 1;
my $Summaries;

my $Descriptions =
	{
	 'Name'			=> {Order=>1, Desc=>'Partition Name' },
	 'BaseName'		=> {Order=>2, Desc=>'Base Name'},
	 'DevName'		=> {Order=>3, Desc=>'Device Name' },
	 'DevPath'		=> {Order=>4, Desc=>'Device Path'},
	 'DevPathRaw'		=> {Order=>5, Desc=>'Device Path Raw'},
	 'Slice'		=> {Order=>6, Desc=>'Slice'},
	 'Num'			=> {Order=>7, Desc=>'Partition #'},
	 'Type'			=> {Order=>8, Desc=>'Type'},
	 'TypeDesc'		=> {Order=>9, Desc=>'Type Description'},
	 'TypeNum'		=> {Order=>10, Desc=>'Type Number'},
	 'UsageStatus'		=> {Order=>11, Desc=>'Usage Status'},
	 'MntName'		=> {Order=>12, Desc=>'Mount Name'},
	 'MntOpts'		=> {Order=>13, Desc=>'Mount Options'},
	 'Size'			=> {Order=>14, Desc=>'Size (MB)'},
	 'AmtUsed'		=> {Order=>15, Desc=>'Amount Used (MB)'},
	 'SecSize'		=> {Order=>16, Desc=>'Sector Size (bytes)'},
	 'StartSect'		=> {Order=>17, Desc=>'Starting Sector'},
	 'EndSect'		=> {Order=>18, Desc=>'Ending Sector'},
	 'NumSect'		=> {Order=>19, Desc=>'Number of Sectors'},
	};
#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Name"} = undef;
    $self->{"DevName"} = undef;
    $self->{"DevPath"} = undef;
    $self->{"DevPathRaw"} = undef;
    $self->{"BaseName"} = undef;
    $self->{"Slice"} = undef;
    $self->{"Num"} = undef;
    $self->{"Type"} = undef;
    $self->{"TypeDesc"} = undef;
    $self->{"TypeNum"} = undef;
    $self->{"UsageStatus"} = undef;
    $self->{"MntName"} = undef;
    $self->{"MntOpts"} = [];
    $self->{"Size"} = undef;
    $self->{"AmtUsed"} = undef;
    $self->{"SecSize"} = undef;
    $self->{"StartSect"} = undef;
    $self->{"EndSect"} = undef;
    $self->{"NumSect"} = undef;

    $self->{"Desc"} = undef;
    $self->{"ORDER"} = undef;
    $self->{"SUMMARY"} = undef;

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}

sub DevName {
    my $self = shift;

    if (!@_) {
	return $self->{"DevName"};
    }

    $self->{"DevName"} = shift;

    return;
}

sub DevPath {
    my $self = shift;

    if (!@_) {
	return $self->{"DevPath"};
    }

    $self->{"DevPath"} = shift;

    return;
}

sub DevPathRaw {
    my $self = shift;

    if (!@_) {
	return $self->{"DevPathRaw"};
    }

    $self->{"DevPathRaw"} = shift;

    return;
}

sub BaseName {
    my $self = shift;

    if (!@_) {
	return $self->{"BaseName"};
    }

    $self->{"BaseName"} = shift;

    return;
}

sub Num {
    my $self = shift;

    if (!@_) {
	return $self->{"Num"};
    }

    $self->{"Num"} = shift;

    return;
}

sub Slice {
    my $self = shift;

    if (!@_) {
	return $self->{"Slice"};
    }

    $self->{"Slice"} = shift;

    return;
}

sub Type {
    my $self = shift;

    if (!@_) {
	return $self->{"Type"};
    }

    $self->{"Type"} = shift;

    return;
}

sub TypeDesc {
    my $self = shift;

    if (!@_) {
	return $self->{"TypeDesc"};
    }

    $self->{"TypeDesc"} = shift;

    return;
}

sub TypeNum {
    my $self = shift;

    if (!@_) {
	return $self->{"TypeNum"};
    }

    $self->{"TypeNum"} = shift;

    return;
}

sub UsageStatus {
    my $self = shift;

    if (!@_) {
	return $self->{"UsageStatus"};
    }

    $self->{"UsageStatus"} = shift;

    return;
}

sub MntName {
    my $self = shift;

    if (!@_) {
	return $self->{"MntName"};
    }

    $self->{"MntName"} = shift;

    return;
}

sub Size {
    my $self = shift;

    if (!@_) {
	return $self->{"Size"};
    }

    $self->{"Size"} = shift;

    return;
}

sub AmtUsed {
    my $self = shift;

    if (!@_) {
	return $self->{"AmtUsed"};
    }

    $self->{"AmtUsed"} = shift;

    return;
}

sub SecSize {
    my $self = shift;

    if (!@_) {
	return $self->{"SecSize"};
    }

    $self->{"SecSize"} = shift;

    return;
}

sub StartSect {
    my $self = shift;

    if (!@_) {
	return $self->{"StartSect"};
    }

    $self->{"StartSect"} = shift;

    return;
}

sub EndSect {
    my $self = shift;

    if (!@_) {
	return $self->{"EndSect"};
    }

    $self->{"EndSect"} = shift;

    return;
}

sub NumSect {
    my $self = shift;

    if (!@_) {
	return $self->{"NumSect"};
    }

    $self->{"NumSect"} = shift;

    return;
}

sub MntOpts {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"MntOpts"} };
    }

    @{ $self->{"MntOpts"} } = @_;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;

    if ($Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    return $Descriptions->{$Key}->{'Desc'};
}
#
# Fetch/set summary of this item
#
sub SUMMARY {
    my $self = shift;
    my $Desc = shift;

    if ($Desc) {
	# Set description
	$Summaries->{$self->Name} = $Desc;
	return $Desc;
    }

    # Return summary
    return $Summaries->{$self->Name};
}

#
# Order item is presented in
#
sub ORDER {
    my $self = shift;
    my $Key = shift;
    my $Order = shift;

    if ($Key && $Order) {
	# Set order
	$PresentOrder->{$Key} = $Order;
	return $Order;
    }

    # Return order
    return $PresentOrder->{$Key} || $Descriptions->{$Key}->{"Order"};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (Eq($Fields[1], 'name')) {
	my $key = $Fields[3];

	$self->DevName($Fields[2]);
	$self->BaseName($Fields[3]);
	$self->Name($Fields[4]);
	$self->Slice($Fields[5]);
	$self->Num($Fields[6]);
	$self->DevPathRaw($Fields[7]);
	$self->Type($Fields[8]);
	$self->TypeDesc($Fields[9]);
	$self->TypeNum($Fields[10]);
	$self->UsageStatus($Fields[11]);
	$self->MntName($Fields[12]);
	$self->MntOpts(split(',', $Fields[13]));
	$self->Size($Fields[14]);
	$self->AmtUsed($Fields[15]);
	$self->SecSize($Fields[16]);
	$self->StartSect($Fields[17]);
	$self->EndSect($Fields[18]);
	$self->NumSect($Fields[19]);

	# Set presentation order
	$self->ORDER($key, $PresentOrderTrack++);
    }

    return $self;
}

1; # Make require/use happy
