#
# $Id: mcPrinter.pm,v 1.3 2002/07/27 22:06:52 mcooper Exp $
#
# Printer object
#

package mcPrinter;
require 5.003;

use mcDebug;
use mcMisc;
use mcPrinterInfo;

my $PresentOrderTrack = 1;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;
    $self->{"ORDER"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Order item is presented in
#
sub ORDER {
    my $self = shift;
    my $Key = shift;
    my $Order = shift;

    if ($Key && $Order) {
	# Set order
	$PresentOrder->{$Key} = $Order;
	return $Order;
    }

    # Return order
    return $PresentOrder->{$Key};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "printer")) {
	return;
    }

    my $Name = $Fields[2];
    my $PrinterInfo = mcPrinterInfo->New;
    # Lookup the PrinterInfo entry (if any)
    my $pi = $self->Entries($Name);
    if (!$pi) {
	# Need a new object
	$pi = $PrinterInfo;
    }
    # Decode and Set
    $pi->Decode(@Fields);
    # Add it back
    $self->Entries({$Name => $pi});

    # Set presentation order
    $self->ORDER($Name, $PresentOrderTrack++);

    return $self;
}

1; # Make require/use happy
