#
# $Id: mcStatus.pm,v 1.4 2003/04/19 22:15:39 mcooper Exp $
#
# MagniComp Status object
#

package mcStatus;
require 5.003;

sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Code"} = undef;		# Numeric code: SUCCESS or FAILURE
    $self->{"Value"} = undef;		# Return value
    $self->{"ErrMsg"} = undef;		# Message describing error
    $self->{"Result"} = undef;		# Where function places result data
    $self->{"SUCCESS"} = undef;		# Returns 0
    $self->{"FAILURE"} = undef;		# Returns -1
    $self->{"HARD"} = undef;		# Value: Hard failure
    $self->{"SOFT"} = undef;		# Value: Soft failure

    bless ($self, $class);

    return $self;
}

sub Code {
    my $self = shift;

    if (!@_) {
	return $self->{"Code"};
    }

    $self->{"Code"} = shift;

    return;
}

sub Value {
    my $self = shift;

    if (!@_) {
	return $self->{"Value"};
    }

    $self->{"Value"} = shift;

    return;
}

sub HARD {
    my $self = shift;

    if (!@_) {
	return $self->{"HARD"};
    }

    $self->{"HARD"} = shift;

    return;
}

sub SOFT {
    my $self = shift;

    if (!@_) {
	return $self->{"SOFT"};
    }

    $self->{"SOFT"} = shift;

    return;
}

sub ErrMsg {
    my $self = shift;

    if (!@_) {
	return $self->{"ErrMsg"};
    }

    my $fmt = shift;
    $self->{"ErrMsg"} = sprintf($fmt, @_);

    return;
}

sub Result {
    my $self = shift;

    if (!@_) {
	return $self->{"Result"};
    }

    $self->{"Result"} = shift;

    return;
}

sub SUCCESS {
    my $self = shift;

    return 0;
}

sub FAILURE {
    my $self = shift;

    return -1;
}

1;
