#
# $Id: mcStreamFile.pm,v 1.1 2003/04/19 22:15:33 mcooper Exp $
#
# Stream driver for Files
#

package mcStreamFile;
require 5.003;

use mcGlobals;
use mcMisc;
use mcDebug;
use mcStatus;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Open"} = undef;
    $self->{"Close"} = undef;
    $self->{"ReadLine"} = undef;

    bless ($self, $class);

    return $self;
}

#
# Read one line
#
sub ReadLine {
    my $self = shift;
    my $fh = $self->{FH};

    if (!$fh) {
	return;
    }

    if (eof($fh)) {
	return undef;
    }

    my $Line = <$fh>;
    if (length($Line)) {
	chop($Line);
    }

    return $Line || "";
}

#
# Open a stream to a file
#
sub Open {
    my $self = shift;
    my $SysInfo = shift;
    my $Args = shift;
    my $File = $SysInfo->InputFile;
    my $Status = mcStatus->New;

    Debug("StreamFile->Open: Using inputfile <%s>", $File);
    $self->{FH} = GetFH();
    if (!open($self->{FH}, '<', $File)) {
	Error("%s: Open for read failed: %s",  $File, $!);
	$Status->Code($Status->FAILURE);
	$Status->Value(-2);	# Hard error
	return $Status;
    }

    $Status->Code($Status->SUCCESS);

    return $Status;
}

#
# Close a stream
#
sub Close {
    my $self = shift;

    if ($self->{FH}) {
	close($self->{FH});
	$self->{FH} = undef;
    }
}
