#
# $Id: mcSysConf.pm,v 1.3 2002/07/08 01:52:20 mcooper Exp $
#
# SysConf object
#

package mcSysConf;
require 5.003;

use mcDebug;
use mcMisc;
use mcName;

my $PresentOrderTrack = 1;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;
    $self->{"ORDER"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Order item is presented in
#
sub ORDER {
    my $self = shift;
    my $Key = shift;
    my $Order = shift;

    if ($Key && $Order) {
	# Set order
	$PresentOrder->{$Key} = $Order;
	return $Order;
    }

    # Return order
    return $PresentOrder->{$Key};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "sysconf")) {
	return;
    }

    my $Name = $Fields[2];
    my $Entry = mcName->New;
    # Lookup the entry (if any)
    my $e = $self->Entries($Name);
    if (!$e) {
	# Need a new object
	$e = $Entry;
    }
    # Decode and Set
    $e->Decode(@Fields);
    # Add it back
    $self->Entries({$Name => $e});

    # Set presentation order
    $self->ORDER($Name, $PresentOrderTrack++);

    return $self;
}

1; # Make require/use happy
