#
# $Id: mcType.pm,v 1.2 2003/04/19 23:52:38 mcooper Exp $
#
# SysInfo Type object.
# This object describes a type keyword.
#

package mcType;
require 5.003;

use mcMisc;
use mcDebug;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Name"} = undef;		# Object type name
    $self->{"Desc"} = undef;		# Description

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}
sub Desc {
    my $self = shift;

    if (!@_) {
	return $self->{"Desc"};
    }

    $self->{"Desc"} = shift;

    return;
}

#
# Decode an array of type fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "type")) {
	return;
    }

    $self->Name($Fields[1]);
    $self->Desc($Fields[2]);

    return $self;
}

1;
