#
# $Id: GuiButtons.pm,v 1.5 2003/05/03 20:47:30 mcooper Exp $
#
# GUI Button functions
#

package GuiButtons;

require 5.003;

require Exporter;

use mcDebug;
use uiMisc;
use uiGlobals;

my @ArrangeButtons;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   ButtonStates ArrangeButtonAdd
		  );
}

#
# Change ArrangeButton's States
#
sub ArrangeButtonState {
##    Debug("ArrangeButtonState called.");

    my $Class = uiClass::ClassGet('Hardware');

    my $State;
    if ($Class->{Entries} && $Class->{Show}) {
	$State = 'normal';
    } else {
	$State = 'disable';
    }

    foreach my $b (@ArrangeButtons) {
	$b->configure(-state=>$State);
    }
}

#
# Add the given button to the list
#
sub ArrangeButtonAdd {
    my $Btn = shift;

    push(@ArrangeButtons, $Btn);
}

#
# Set the current button state for all buttons
#
sub ButtonStates {
    ArrangeButtonState();
}

1;
