#
# $Id: GuiOpen.pm,v 1.4 2002/03/09 01:09:19 mcooper Exp mcooper $
#
# GUI Open Input functions
#

package GuiOpen;

require 5.003;

require Exporter;

use mcDebug;
use uiMisc;
use uiGlobals;

#
# Make sure to update ui/sysinfoui.in -> $PerlModules to match
# the 'use' commands below.
#
use Tk;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   OpenInputFile
		  );
}
#
# Process Open Input file
#
sub OpenInputSet {
    my $File = shift;

    if (!length($File)) {
	return;
    }
    $InFile = $File;

    Status("Removing existing entries . . .");
    if ($Tree) {
	foreach my $Class (@Classes) {
	    Debug("Deleting class <%s>", $Class);
	    if ($Tree->info('exists', $Class)) {
		$Tree->delete('offsprings', $Class);
		$Tree->delete('entry', $Class);
	    }
	}
    }

    $Table = undef;
    $SysInfo = undef;

    Status("");

    uiGUI::Retrieve();
}

#
# Open input file
#
sub OpenInputFile {
    my $Args = shift;
    my $MainWindow = $Args->{MainWindow};

    my $File = $MainWindow->getOpenFile(-title=>WinTitle('Open "sysinfo -format report" data file'));
    Debug("OpenInputFile: getOpenFile returned <%s>", $File);

    if ($File && length($File)) {
	OpenInputSet({File=>$File});
    }
}

1;
