#
# $Id: uiCliShowKernel.pm,v 1.3 2002/07/13 21:38:44 mcooper Exp $
#
# SysInfo CLI Show Kernel functions
#

package uiCliShowKernel;

require 5.003;
require Exporter;

use POSIX;

use mcDebug;
use uiGlobals;
use uiClass;
use uiMisc;
use uiPresent;
use uiPresentItem;
use uiPresentProp;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   CliShowKernel
		  );
}

#
# CLI Show Kernel class info
#
sub CliShowKernel {
    my $Args = shift;
    my $SysInfo = $Args->{SysInfo};
    my $Entries = $SysInfo->Entries;

    Debug("CLI: ShowKernel");

    if (!$SysInfo) {
	Debug("CliShowKernel: No SysInfo data was found.");
	return -1;
    }

    my $Present = uiPresent->New;
    my $Class = ClassGet($CL_KERNEL);
    $Present->Class($Class);

    my @Items = keys %$Entries;
    my @PrItems;

    foreach my $item (@Items) {
	my $Kernel = $Entries->{$item};

	#
	# Setup the properties for this item.
	#
	my $PrItem = uiPresentItem->New;
	$PrItem->Desc($Kernel->Desc);
	$PrItem->Name($Kernel->Name);
	$PrItem->Value($Kernel->Value);
	$PrItem->SysInfoObj($Kernel);

	push(@PrItems, $PrItem);
    }

    # Sort the items into alphabetical order
    $Present->Items(sort {$a->Summary cmp $b->Summary} @PrItems);

    $Present->Show({Class=>$Class});
}

1;
