#
# $Id: uiCliShowSysConf.pm,v 1.3 2002/07/14 19:35:13 mcooper Exp $
#
# SysInfo CLI Show SysConf functions
#

package uiCliShowSysConf;

require 5.003;
require Exporter;

use POSIX;

use mcDebug;
use uiGlobals;
use uiClass;
use uiMisc;
use uiPresent;
use uiPresentItem;
use uiPresentProp;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   CliShowSysConf
		  );
}

#
# CLI Show SysConf class info
#
sub CliShowSysConf {
    my $Args = shift;
    my $SysInfo = $Args->{SysInfo};
    my $Entries = $SysInfo->Entries;

    Debug("CLI: ShowSysConf");

    if (!$SysInfo) {
	Debug("CliShowSysConf: No SysInfo data was found.");
	return -1;
    }

    my $Present = uiPresent->New;
    my $Class = ClassGet($CL_SYSCONF);
    $Present->Class($Class);

    my @Items = keys %$Entries;
    my @PrItems;

    foreach my $item (@Items) {
	my $SysConf = $Entries->{$item};

	#
	# Setup the properties for this item.
	#
	my $PrItem = uiPresentItem->New;
	$PrItem->Desc($SysConf->Desc);
	$PrItem->Name($SysConf->Name);
	$PrItem->Value($SysConf->Value);
	$PrItem->SysInfoObj($SysConf);

	push(@PrItems, $PrItem);
    }

    # Sort the items into alphabetical order
    $Present->Items(sort {$a->Summary cmp $b->Summary} @PrItems);

    $Present->Show({Class=>$Class});
}

1;
