#!/usr/bin/perl
#
# $Id: uiGlobals.pm.in,v 1.42 2003/04/15 20:26:08 mcooper Exp $
#
# Globals for user interface
#

package uiGlobals;

require 5.003;
require Exporter;

#
# Global variables
#
$Title				= 'MagniComp SysInfo';
$UIversion			= '$Revision: 1.42 $'; # '
$BinProgramName			= 'sie';
$PrefsFile			= $ENV{'HOME'} . '/.mcsysinforc';
$PathSep			= '&';
$Debug 				= undef;
$HelpTips 			= undef;
$HelpTipsBackground		= '#FFFF99';
$MainWindow 			= undef;
$DataTabs 			= undef;
$PropertiesButton 		= undef;
$InFile 			= undef;
$SysInfo 			= undef;
$SysInfoPath 			= undef;
$MainGeometry			= '800x600';	# MainWindow geometry
$WidthChars			= 60;
$SplashLogo			= 'sysinfo-logo-image-large';
$SysInfoLogo18			= 'sysinfo-logo-image-18';
$SysInfoIcon			= 'sysinfo-icon-36x36';
$MagniCompLogo300		= 'magnicomp-logo-large';
$MyHostName 			= undef;
$StatusMessage 			= undef; # Obsoleted by Balloon $HelpTips
$AfterID 			= undef;
$IconDivider 			= undef;
$OpenInputWin 			= undef;
#
# Interface Mode
#
$IM_CLI = 1;
$IM_GUI = 2;
$CurrentIM 			= undef;

#
# Colors
#
$Hdr1Color			= '#ccccff';
$Hdr2Color			= '#99ffff';
$Row1aColor			= '#eeeeee';
$Row1bColor			= '#dddddd';
$Row2aColor			= '#ccffcc';
$Row2bColor			= '#ccffff';

#
# Header definetions for $FT_COLUMNS
#
# Valid Variables are:
#	Name		Column header name
#	Type		Type of field (image or text)
#	Key		Valid object key (i.e. $obj->$Key)
#	WidthPct	Width of field as a percentage
#	MinWidth	Min width of field in chars (bytes)
#				 0 = No width padding
#				-1 = Use longest field width
#	MaxWidth	Max width of field in chars
#				-1 = Amt remaining < term width
#	HAlign		Horizontal Alignment indicator (left is default)
#
my @HardwareHeaders = (
	   { Name=>'ICON', 	Type=>'image' },
	   { Name=>'DEVICE', 	Type=>'text',   Key=>'Name',
	     MinWidth=>10,	WidthPct=>14 },
	   { Name=>'VENDOR', 	Type=>'text',   Key=>'Vendor',
	     MinWidth=>11,	WidthPct=>16 },
	   { Name=>'MODEL', 	Type=>'text',   Key=>'Model',
	     MinWidth=>19,	WidthPct=>25 },
	   { Name=>'TYPE', 	Type=>'text',	Key=>'Type',
	     MinWidth=>10,	WidthPct=>16 },
	   { Name=>'CLASS', 	Type=>'text',	Key=>'ClassType',
	     MinWidth=>8,	WidthPct=>8,	HAlign=>'center' },
	   { Name=>'SPEED', 	Type=>'text',	Key=>'Speed',
	     MinWidth=>8,	WidthPct=>8, 	HAlign=>'right' },
	   { Name=>'CAPACITY',	Type=>'text',	Key=>'Capacity',
	     MinWidth=>10,	WidthPct=>10, 	HAlign=>'right' },
      );

my @PartHeaders = (
	   { Name=>'DEVICE', 	Type=>'text',	Key=>'Name',
	     MinWidth=>10,	WidthPct=>13 },
	   { Name=>'CAPACITY',	Type=>'text',	Key=>'Size',
	     ConvertFrom=>'MB',
	     MinWidth=>10,	WidthPct=>13,	HAlign=>'right' },
	   { Name=>'USED', 	Type=>'text',	Key=>'AmtUsed',
	     ConvertFrom=>'MB',
	     MinWidth=>10,	WidthPct=>13,	HAlign=>'right' },
	   { Name=>'TYPE', 	Type=>'text',	Key=>'Type',
	     MinWidth=>10,	WidthPct=>13 },
	   { Name=>'USAGE', 	Type=>'text',	Key=>'MntName',
	     MinWidth=>0,	WidthPct=>46 },
      );

my @PrinterHeaders = (
	   { Name=>'ICON', 	Type=>'image' },
	   { Name=>'NAME', 	Type=>'text',	Key=>'Name',
	     MinWidth=>-1,	WidthPct=>20 },
	   { Name=>'ALIASES', 	Type=>'text',	Key=>'Aliases',
	     MinWidth=>-1,	WidthPct=>10 },
	   { Name=>'SERVER', 	Type=>'text',	Key=>'Server',
	     MinWidth=>-1,	WidthPct=>10 },
	   { Name=>'LANGUAGES', Type=>'text',	Key=>'Langs',
	     MinWidth=>-1,	WidthPct=>10 },
	   { Name=>'DESCRIPTION', Type=>'text',	Key=>'Desc',
	     MinWidth=>0,	WidthPct=>30 },
      );

my @SoftwareHeaders = (
	   { Name=>'NAME', 	Type=>'text',	Key=>'Name',
	     MinWidth=>-1 },
	   { Name=>'VERSION', 	Type=>'text',	Key=>'Version',
	     MinWidth=>-1,	MaxWidth=>10 },
	   { Name=>'REVISION', 	Type=>'text',	Key=>'Revision',
	     MinWidth=>-1,	MaxWidth=>10 },
	   { Name=>'SIZE', 	Type=>'text',	Key=>'DiskUsage',
	     ConvertFrom=>'Bytes',	HAlign=>'right',
	     MinWidth=>-1 },
	   { Name=>'DESCRIPTION',Type=>'text',	Key=>'Description',
	     MinWidth=>0,	MaxWidth=>-1 },
      );

my @GenericHeaders  = (
	   { Name=>'DESCRIPTION',	Type=>'text',	Key=>'Desc',
	     MinWidth=>-1 },
	   { Name=>'VALUE',		Type=>'text',	Key=>'Value',
	     MinWidth=>0 },
      );

my @KeyValDescHeaders  = (
	   { Name=>'DESCRIPTION',	Type=>'text',	Key=>'Desc',
	     MinWidth=>-1 },
	   { Name=>'KEY',		Type=>'text',	Key=>'Name',
	     MinWidth=>-1 },
	   { Name=>'VALUE',		Type=>'text',	Key=>'Value',
	     MinWidth=>0 },
      );

my @LicenseHeaders  = (
	   { Name=>'SOFTWARE',		Type=>'text',	Key=>'SoftName',
	     MinWidth=>-1 },
	   { Name=>'SW VERSION',	Type=>'text',	Key=>'SoftVer',
	     MinWidth=>-1 },
	   { Name=>'TYPE',		Type=>'text',	Key=>'TypeDesc',
	     MinWidth=>-1 },
	   { Name=>'RTU',		Type=>'text',	Key=>'Count',
	     MinWidth=>4,		HAlign=>'right' },
	   { Name=>'ISSUED',		Type=>'text',	Key=>'IssueDate',
	     MinWidth=>-1,		HAlign=>'right' },
	   { Name=>'STARTS',		Type=>'text',	Key=>'StartDate',
	     MinWidth=>-1,		HAlign=>'right' },
	   { Name=>'EXPIRES',		Type=>'text',	Key=>'ExpireDate',
	     MinWidth=>-1,		HAlign=>'right' },
      );

my @NetIfHeaders = (
	   { Name=>'NAME', 	Type=>'text',	Key=>'Name',
	     MinWidth=>-1,	WidthPct=>20 },
	   { Name=>'ADDRESS', 	Type=>'text',	Key=>'HostAddr',
	     MinWidth=>-1,	WidthPct=>20 },
	   { Name=>'NETMASK', Type=>'text',	Key=>'NetMask',
	     MinWidth=>-1,	WidthPct=>20 },
	   { Name=>'BROADCAST', Type=>'text',	Key=>'BroadAddr',
	     MinWidth=>-1,	WidthPct=>20 },
	   { Name=>'SPEED', 	Type=>'text',	Key=>'Speed',
	     MinWidth=>-1,	WidthPct=>10 },
	   { Name=>'DUPLEX', 	Type=>'text',	Key=>'Duplex',
	     MinWidth=>-1,	WidthPct=>10 },
      );

#
# Class Name Variables
#
$CL_GENERAL	= 'General';
$CL_HARDWARE	= 'Hardware';
$CL_PARTITION	= 'Partition';
$CL_PRINTER	= 'Printer';
$CL_SOFTWARE	= 'Software';
$CL_KERNEL	= 'Kernel';
$CL_SYSCONF	= 'SysConf';
$CL_LICENSE	= 'License';
$CL_NETIF	= 'NetIf';
$CL_NETWORK	= 'Network';

#
# Canonical list of all Classes
#
$Classes = [
	       {Name=>$CL_GENERAL,
	       	Show=>1,			# Show this by default?
		ExpandableItems=>0,		# Have expandable sub items?
		SlowRetrieve=>0,		# Probe/retrieve is slow?
		SingleEntry=>1,			# We have one top level entry
		SimpleKeyValue=>1,		# We have just key=val params
		Headers=>\@GenericHeaders,
		Banner=>'General Information',
	        Desc=>'General system configuration'},
	       {Name=>$CL_HARDWARE,
	       	Show=>0,
		Hide=>1,			# Hide props on GUI start
		ExpandableItems=>1,
		Headers=>\@HardwareHeaders,
		Banner=>'Hardware Information',
		Desc=>'Installed hardware devices'},
	       {Name=>$CL_PARTITION,
	       	Show=>0,
		Hide=>1,			# Hide props on GUI start
		ExpandableItems=>1,
		Headers=>\@PartHeaders,
		Banner=>'Partition Information',
		Desc=>'Disk partitions'},
	       {Name=>$CL_NETIF,
	       	Show=>0,
		Hide=>1,			# Hide props on GUI start
		ExpandableItems=>1,
		Headers=>\@NetIfHeaders,
		Banner=>'Network Interface Information',
		Desc=>'All Network Interfaces'},
	       {Name=>$CL_NETWORK,
	       	Show=>0,			# Show this by default?
		ExpandableItems=>0,		# Have expandable sub items?
		SlowRetrieve=>0,		# Probe/retrieve is slow?
		SingleEntry=>1,			# We have one top level entry
		SimpleKeyValue=>1,		# We have just key=val params
		Headers=>\@GenericHeaders,
		Banner=>'Network Information',
	        Desc=>'Network configuration information'},
	       {Name=>$CL_PRINTER,
	       	Show=>0,
		Hide=>1,			# Hide props on GUI start
		ExpandableItems=>1,
		Headers=>\@PrinterHeaders,
		Banner=>'Printer Information',
		Desc=>'Printer Queues'},
	       {Name=>$CL_SOFTWARE,
	       	Show=>0,
		Hide=>1,			# Hide props on GUI start
		ExpandableItems=>1,
		SlowRetrieve=>1,
		Headers=>\@SoftwareHeaders,
		Banner=>'Software Information',
		Desc=>'Installed software'},
	       {Name=>$CL_LICENSE,
	       	Show=>0,
		ExpandableItems=>1,
		Headers=>\@LicenseHeaders,
		Banner=>'License Information',
		Desc=>'Software Licenses'},
	       {Name=>$CL_KERNEL,
	       	Show=>0,
		NoProps=>1,			# We have no properties
		SimpleKeyValue=>1,		# We have just key=val params
		ExpandableItems=>0,
		Headers=>\@GenericHeaders,
		Banner=>'Kernel Information',
		Desc=>'Kernel configuration'},
	       {Name=>$CL_SYSCONF,
	       	Show=>0,
		NoProps=>1,			# We have no properties
		ExpandableItems=>0,
		Headers=>\@KeyValDescHeaders,
		Banner=>'System Configuration Information',
		Desc=>'System configuration'},
	       ];

#
# Format Values
#
$FT_TREE	= 'tree';
$FT_COLUMNS	= 'columns';
$FT_REPORT	= 'report';
$FW_TREE	= 'Tree';	# Should be the official widget names
$FW_COLUMNS	= 'HList';	# Should be the official widget names
$FormatTable = {
	$FT_TREE => 	{ Order=>0, Name=>$FT_TREE, 	
			  Icon=>'tree', 
			  Widget=>$FW_TREE,
			  Desc=>'Hierarchical Tree', },
	$FT_COLUMNS => 	{ Order=>1, Name=>$FT_COLUMNS,
		 	  Icon=>'columns',
			  Widget=>$FW_COLUMNS,
			  Desc=>'Fixed columns and rows' },
	$FT_REPORT => 	{ Order=>2, Name=>$FT_REPORT,
			  Desc=>'Program parsable report' },
};
$FormatSelected = $FT_TREE;	# Indicate which format is currently selected

#
# Encode Values
#
$EN_TEXT	= 'text';
$EN_HTML	= 'html';
$EncodeTable = {
	$EN_TEXT =>	{ Order=>0, Name=>$EN_TEXT, Desc=>'ASCII Text' },
	$EN_HTML =>	{ Order=>1, Name=>$EN_HTML, Desc=>'HTML Markup Language' },
};
$EncodeSelected = $ML_TEXT;	# Indicate which is currently selected

#
# MsgLevel values
#
$ML_TERSE	= 'terse';
$ML_BRIEF	= 'brief';
$ML_GENERAL	= 'general';
$ML_DESC	= 'descriptions';
$ML_CONFIG	= 'config';
$ML_ALL		= 'all';
$MsgLevelTable = {
	$ML_TERSE	=> { Order=>0, Name=>$ML_TERSE,
			     Desc=>'Values only (for parsing)' },
	$ML_BRIEF	=> { Order=>1, Name=>$ML_BRIEF,
			     Desc=>'Brief, but human readable' },
	$ML_GENERAL	=> { Order=>2, Name=>$ML_GENERAL,
			     Desc=>'General/summary information' },
	$ML_DESC	=> { Order=>3, Name=>$ML_DESC,
			     Desc=>'Description information' },
	$ML_CONFIG	=> { Order=>4, Name=>$ML_CONFIG,
			     Desc=>'Configuration information' },
	$ML_ALL		=> { Order=>5, Name=>$ML_ALL,
			     Desc=>'All levels of information'},
};
$MsgLevelSelected = $ML_GENERAL;	# Indicate which is currently selected

#
# MsgClass values
#
$MC_INFO	= 'info';
$MC_HINT	= 'hint';
$MC_WARN	= 'warn';
$MC_GERROR	= 'gerror';
$MC_CERROR	= 'cerror';
$MC_UNKNOWN	= 'unknown';
$MC_DBG		= 'debug';
$MC_ALL		= 'all';
$MsgClassTable = {
	$MC_INFO	=> { Order=>0, Name=>$MC_INFO,
				Desc=>'Normal information' },
	$MC_HINT	=> { Order=>0, Name=>$MC_HINT,
				Desc=>'Hints and tips' },
	$MC_WARN	=> { Order=>0, Name=>$MC_WARN,
				Desc=>'Warnings' },
	$MC_GERROR	=> { Order=>0, Name=>$MC_GERROR,
				Desc=>'General errors' },
	$MC_CERROR	=> { Order=>0, Name=>$MC_CERROR,
				Desc=>'Critical error' },
	$MC_UNKNOWN	=> { Order=>0, Name=>$MC_UNKNOWN,
				Desc=>'Messages about unknown values' },
	$MC_DBG		=> { Order=>0, Name=>$MC_DBG,
				Desc=>'Debugging information' },
	$MC_ALL		=> { Order=>0, Name=>$MC_ALL,
				Desc=>'All message classes' },
};

#
# Arrangement values
#
$AR_CONNECT			= 'Connection';
$AR_TYPE			= 'Type';
$ArrangeTable = {
	$AR_CONNECT => {
		Order=>0,			# Order to list in
		Name=>$AR_CONNECT,		# Canonical name
		Classes=>[ $CL_HARDWARE ],	# What classes this applies to?
		Icon=>'domino16',		# Icon to use
	},
	$AR_TYPE => {
		Order=>1,
		Name=>$AR_TYPE,
		Classes=>[ $CL_HARDWARE ],
		Icon=>'domino15',
	},
};
$ArrangeDefault = $AR_CONNECT;			# Default

#
# Fonts
#
$Font				= 'arial 12';
$FontMenuTitle			= $Font . ' bold';
$FontMenuItem			= $Font;
$FontTab			= $Font . ' bold';
$FontError			= $Font . ' bold';
$FontHdr			= $Font;
$FontLabel			= $Font;
$FontButton			= $Font;
$FontEntry			= $Font;
$FontFixed			= 'fixed 12 normal'; # Must be a fixed width
$FontTree			= $FontFixed;
$FontText			= $Font;

#
# Property States
#
$PS_OPEN			= 'open';
$PS_CLOSE			= 'close';

#
# @*@ are filled in by configure
# The tests are done to allow these variables to be set in 
# environment of the caller.
#
# NOTE: These variables match what's in "setup"
#
$prefix 			= $ENV{'prefix'};
$cfdir 				= $ENV{'cfdir'};
$exec_prefix 			= $ENV{'exec_prefix'};
$DefaultLibExecDir 		= $ENV{'DEFAULT_LIBEXECDIR'};
$LibExecDir			= $ENV{'SYSINFOLIBEXECDIR'};
if (!length($prefix)) {
    $prefix='/opt/sysinfo';
}
if (!length($cfdir)) {
    $cfdir='/opt/sysinfo/config';
}
if (!length($exec_prefix)) {
    $exec_prefix='/opt/sysinfo';
}
if (!length($DefaultLibExecDir)) {
    $DefaultLibExecDir='/opt/sysinfo/libexec';
}
if (!length($LibExecDir)) {
    $LibExecDir = $DefaultLibExecDir;
}
$LicenseTermsFile = $prefix . "/LICENSE.txt";

#
# Export variables
#
BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   $Title $UIversion $BinProgramName
		   $PathSep
		   $PrefsFile $InFile $SysInfo $SysInfoPath
		   $MainWindow $DataTabs
		   $HelpTips $HelpTipsBackground
		   $MainGeometry $WidthChars $MyHostName $StatusMessage
		   $AfterID $IconDivider $OpenInputWin
		   $prefix $cfdir $exec_prefix
		   $DefaultLibExecDir $LibExecDir
		   $SplashLogo $SysInfoIcon $SysInfoLogo18 $MagniCompLogo300
		   $LicenseTermsFile
		   $Debug $PropertiesButton
		   $FormatTable $FormatSelected
		   $FT_TREE $FT_COLUMNS $FT_REPORT
		   $FW_TREE $FW_COLUMNS
		   $EncodeTable
		   $EN_TEXT $EN_HTML
		   $PS_OPEN $PS_CLOSE
		   $Font
		   $FontMenuTitle
		   $FontMenuItem
		   $FontTab $FontHdr
		   $FontLabel
		   $FontButton
		   $FontEntry
		   $FontError
		   $FontTree
		   $FontText
		   $FontFixed
		   $Classes
		   $CL_GENERAL $CL_HARDWARE $CL_PARTITION $CL_SOFTWARE
		   $CL_PRINTER $CL_LICENSE $CL_NETIF $CL_NETWORK
		   $CL_KERNEL $CL_SYSCONF
		   $ArrangeTable $ArrangeDefault
		   $AR_CONNECT $AR_TYPE
		   $CurrentIM $IM_CLI $IM_GUI
		   $ML_TERSE $ML_BRIEF $ML_GENERAL $ML_DESC $ML_CONFIG $ML_ALL
		   $MsgLevelTable
		   $MC_INFO $MC_HINT $MC_WARN $MC_GERROR $MC_CERROR
		   $MC_UNKNOWN $MC_DBG $MC_ALL
		   $MsgClassTable
		   $Hdr1Color $Hdr2Color
		   $Row1aColor $Row1bColor $Row2aColor $Row2bColor
		  );
}

1;
