#
# $Id: uiHtml.pm,v 1.6 2003/03/15 22:28:47 mcooper Exp $
#
# HTML object and functions
#

package uiHtml;
require 5.003;

require Exporter;
use CGI qw(:all);
use Sys::Hostname;

use mcDebug;
use uiMisc;
use uiGlobals;
use uiMsgLevel;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   HtmlStart HtmlStartClass HtmlEnd HtmlEndClass
		   HtmlBanner HtmlPrt
		  );
}

#
# Make sure to return something 
#
sub HtmlPrt {
    my $s = shift;

    if (length($s)) {
	return $s;
    } else {
	return '&nbsp;';
    }
}

#
# Display String as a banner
#
sub HtmlBanner {
    my $String = shift;

    print center(h1($String)), "\n";
}

#
# Start HTML Class
#
sub HtmlStartClass {
    my $Present = shift;

    if (MsgLevelIs($ML_ALL, $ML_GENERAL, $ML_DESC, $ML_CONFIG)) {
	HtmlBanner($Present->Banner);
    }
}

#
# End HTML Class
#
sub HtmlEndClass {
    my $Present = shift;
    # Do nothing
}

#
# Start HTML
#
sub HtmlStart {
    my $Present = shift;
    my $Hostname = hostname;

    if (!length($Hostname)) {
	Debug("HtmlStart: Cannot determine system hostname");
    }

    print start_html(-title=>"SysInfo for " . $Hostname,
		     -meta=>{'createdate'=>GetDate(time)},
		     -bgcolor=>'#FFFFFF'), "\n";

    print center(h1(a({href=>"http://www.MagniComp.com/sysinfo/"},
		      "SysInfo"),
		    "for", $Hostname)), "\n";
}

#
# End HTML
#
sub HtmlEnd {
    my $Present = shift;
    my $SysInfo = $Present->SysInfo;
    my $Hostname = hostname;
    my $VerStr;

    if ($SysInfo) {
	my $Version = $SysInfo->Version;
	if ($Version) {
	    $VerStr = 'Version ' . $Version->{PRODUCT},
	}
    }

    print hr, "\n";
    print table(
		Tr(
		   td({align=>'left'},
		      a({href=>"http://www.magnicomp.com/"},
			img({src=>"http://www.MagniComp.com/images/magnicomp-logo-6-36-white.jpg",
			     alt=>"www.MagniComp.com",
			     border=>0})
		       )
		     ),

		   td({nowrap=>1, align=>"left"},
		      font({size=>-1},
			   "Autogenerated by:",
			   a({href=>"http://www.magnicomp.com/"},
			     "MagniComp's"),
			   a({href=>"http://www.magnicomp.com/sysinfo/"},
			     "SysInfo"),
			   $VerStr,
			   br,
			   "Generated on: " . $Hostname,
			   br,
			   "Generated at: " . GetDate(time)),
		     )
		  ),
	       ), "\n";

    print end_html, "\n";
}

1;
