#
# $Id: uiMsgClass.pm,v 1.2 2003/05/07 18:08:20 mcooper Exp $
#
# MsgClass functions
#

package uiMsgClass;

require 5.003;

require Exporter;

use mcDebug;
use uiMisc;
use uiGlobals;

my $MsgClass;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   MsgClassIs MsgClassName MsgClassNames
		   MsgClassSort MsgClassSet MsgClassList
		  );
}

#
# Set the current encode to be $enc
# If no arg is supplied, returns the current MsgClass.
#
sub MsgClassSet {
    my $enc = shift;
    my $err;

    if ($enc || !$MsgClass) {
	if (!($MsgClass = $MsgClassTable->{$enc})) {
	    # Insure that $MsgClass points to something valid
	    $err = sprintf("The string \"%s\" is not a valid -msgclass value.",
			   $enc);
	    Debug("MsgClassSet: %s\n", $err);
	    # Default to something in case error is ignored
	    $MsgClass = $MsgClassTable->{$MC_INFO};
	}
    }

    $MsgClassSelected = $MsgClass->{Name};

    return $err;
}

#
# Sort routine for sorting $MsgClassTable
#
sub MsgClassSort {
    return $MsgClassTable->{$a}->{Order} <=> $MsgClassTable->{$b}->{Order};
}

#
# Return a list/array of valid classs in sorted order
#
sub MsgClassList {
    my @list;

    my @keys = keys %$MsgClassTable;
    foreach my $key (sort MsgClassSort @keys) {
	push(@list, $MsgClassTable->{$key});
    }

    return @list;
}

#
# Return a list/array of valid names
#
sub MsgClassNames {
    my @list;

    my @keys = keys %$MsgClassTable;
    foreach my $key (sort MsgClassSort @keys) {
	push(@list, $key);
    }

    return @list;
}

#
# Is one of @List currently selected as the msgclass?
#
sub MsgClassIs {
    my @List = @_;

    foreach my $name (@List) {
	if (Eq($MsgClassSelected, $name)) {
	    return 1;
	}
    }

    return 0;
}

#
# Return the name of $enc or the current encode if none is specified.
#
sub MsgClassName {
    my $enc = shift;
    my $f = $enc;

    if (!$f) {
	$f = $MsgClass;
    }

    return $f->{Name};
}

1;
