#
# $Id: uiPresentItem.pm,v 1.7 2002/07/14 19:35:26 mcooper Exp $
#
# Presentation item object
#

package uiPresentItem;
require 5.003;

use uiGlobals;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Name"} = undef;
    $self->{"Desc"} = undef;
    $self->{"Value"} = undef;
    $self->{"Summary"} = undef;
    $self->{"SysInfoObj"} = undef;	# The actual object
    $self->{"Next"} = undef;		# Next uiPresentItem (sibling)
    $self->{"Master"} = undef;		# Master uiPresentItem object
    $self->{"Slaves"} = [];		# Array of uiPresentItem children
    $self->{"Props"} = [];		# uiPresentProp objects

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}

sub Desc {
    my $self = shift;

    if (!@_) {
	return $self->{"Desc"};
    }

    $self->{"Desc"} = shift;

    return;
}

sub Value {
    my $self = shift;

    if (!@_) {
	return $self->{"Value"};
    }

    $self->{"Value"} = shift;

    return;
}

sub Summary {
    my $self = shift;

    if (!@_) {
	return $self->{"Summary"};
    }

    $self->{"Summary"} = shift;

    return;
}

sub SysInfoObj {
    my $self = shift;

    if (!@_) {
	return $self->{"SysInfoObj"};
    }

    $self->{"SysInfoObj"} = shift;

    return;
}

sub Props {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"Props"} };
    }

    @{ $self->{"Props"} } = @_;

    return;
}

sub Next {
    my $self = shift;

    if (!@_) {
	return $self->{"Next"};
    }

    $self->{"Next"} = shift;

    return;
}

sub Master {
    my $self = shift;

    if (!@_) {
	return $self->{"Master"};
    }

    $self->{"Master"} = shift;

    return;
}

sub Slaves {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"Slaves"} };
    }

    @{ $self->{"Slaves"} } = @_;

    return;
}

1;
