#
# $Id: uiPresentProp.pm,v 1.3 2002/07/20 22:31:14 mcooper Exp $
#
# Presentation property object
#

package uiPresentProp;
require 5.003;

require Exporter;
use uiGlobals;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   CreateProp
		  );
}

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Order"} = undef;
    $self->{"Desc"} = undef;
    $self->{"Key"} = undef;
    $self->{"Value"} = undef;
    $self->{"Opaque"} = undef;
    $self->{"OpaqueArray"} = undef;

    bless ($self, $class);

    return $self;
}

sub Order {
    my $self = shift;

    if (!@_) {
	return $self->{"Order"};
    }

    $self->{"Order"} = shift;

    return;
}

sub Desc {
    my $self = shift;

    if (!@_) {
	return $self->{"Desc"};
    }

    $self->{"Desc"} = shift;

    return;
}

sub Key {
    my $self = shift;

    if (!@_) {
	return $self->{"Key"};
    }

    $self->{"Key"} = shift;

    return;
}

sub Value {
    my $self = shift;

    if (!@_) {
	return $self->{"Value"};
    }

    $self->{"Value"} = shift;

    return;
}

sub Opaque {
    my $self = shift;

    if (!@_) {
	return $self->{"Opaque"};
    }

    $self->{"Opaque"} = shift;

    return;
}

sub OpaqueArray {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"OpaqueArray"} };
    }

    @{ $self->{"OpaqueArray"} } = @_;

    return;
}

#
# Create a PresentProp object
#
sub CreateProp {
    my $key = shift;
    my $desc = shift;
    my $value = shift;

    my $Prop = uiPresentProp->New;
    $Prop->Key($key);
    $Prop->Desc($desc);
    $Prop->Value($value);

    return $Prop;
}

1;
