#
# $Id: uiStyles.pm,v 1.3 2003/05/04 01:02:38 mcooper Exp $
#
# UI Styles functions
#

package uiStyles;

require 5.003;

require Exporter;

use mcDebug;
use uiMisc;
use uiGlobals;

#
# Variables
#

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   StylesAdd
		  );
}

#
# Add HList styles to $Widget.
#
sub StylesAdd {
    my $Args = shift;
    my $Widget = $Args->{Widget};
    my $Styles;

    #
    # We need styles for odd and even rows and for 'text' and 'image'
    # for each.
    #
    $Styles->{odd}->{text} = $Widget->ItemStyle('text',
						-background=>'#EEEEEE',
						-font=>$Font,
					       );
    $Styles->{odd}->{image} = $Widget->ItemStyle('image',
						-background=>'#EEEEEE',
						);

    $Styles->{even}->{text} = $Widget->ItemStyle('text',
						-background=>'#DDDDDD',
						-font=>$Font,
						);
    $Styles->{even}->{image} = $Widget->ItemStyle('image',
						  -background=>'#DDDDDD',
						 );

    #
    # Header style
    #
    $Styles->{header}->{text} = $Widget->ItemStyle('text',
						   -background=>'#CCFFFF',
						   -font=>$FontMenuTitle,
						  );
    $Styles->{header}->{image} = $Widget->ItemStyle('image',
						    -background=>'#CCFFFF',
						   );

    return $Widget->{Styles} = $Styles;
}

1;
