#
# $Id: uiTextTree.pm,v 1.8 2003/05/06 18:46:01 mcooper Exp $
#
# Tree object
#

package uiTextTree;
require 5.003;

require Exporter;

use mcDebug;
use mcGetSize;
use uiMisc;
use uiGlobals;
use uiMsgLevel;
use uiText;
use uiTextProps;
use uiCliMsg;

BEGIN {
    #
    # Export function
    #
    @ISA      = qw(Exporter);

    #
    # Variables and functions being auto exported
    #
    @EXPORT   = qw(
		   ShowTextTreeItem
		  );
}

#
# Show Text Tree Item
#
sub ShowTextTreeItem {
    my $Present = shift;
    my $Level = shift;
    my $item = shift;
    my $MaxLen = shift;

    my $value = GetValue($item->Value);
    #
    # Class hardware has it's info in Summary or Props so we skip this test
    # in that case.
    #
    if (!length($value) && !$item->Summary &&
	!Eq($Present->Class->{"Name"}, $CL_HARDWARE)) {
	return;
    }

    if (MsgLevelIs($ML_TERSE)) {
	CliMsg("%s\n", $value);
    } elsif (MsgLevelIs($ML_BRIEF)) {
	CliMsg("%s is %s\n", $item->Name, $value);
    } else {
	#
	# Show summary
	#
	if (exists($item->{"Summary"}) && length($item->Summary)) {
	    TextIndent($Level);
	    CliMsg("%s\n", $item->Summary);
	} elsif ($item->Desc && $item->Value) {
	    my $Desc = $item->Desc;
	    if (MsgLevelIs($ML_ALL)) {
		$Desc = $Desc . ' (' . $item->Name . ')';
	    }
	    TextIndent($Level);
	    CliMsg("%-*s %s\n",
		   $MaxLen + 4, $Desc . " is", $value);
	}
    }

    if (MsgLevelIs($ML_ALL, $ML_CONFIG, $ML_DESC)) {
	ShowTextProps({Item=>$item, Present=>$Present, Level=>$Level});
    }
}

1;
