/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * File Check functions
 */

#include "mcbase.h"
#if HAVE_STRING_H
# include <string.h>
#endif
#if HAVE_STRINGS_H
# include <strings.h>
#endif
#if HAVE_STDLIB_H
# include <stdlib.h>
#endif
#include <sys/stat.h>

/*
 * Test to see if FileName exists.
 */
extern int FileExists(char *	FileName,
		      int	Flags)
{
    int				Exists = FALSE;
    struct stat			StatBuf;

    if (!FileName)
	return(0);

    if (stat(FileName, &StatBuf) == 0)
	Exists = TRUE;

#if defined(SIM_DBG) && defined(FF_SILENCE)
    if (FLAGS_OFF(Flags, FF_SILENCE))
	SImsg(SIM_DBG, "File <%s> %s", FileName, 
	      (Exists) ? "Exists" : (char *) SYSERR);
#endif

    return(Exists);
}

/*
 * Test to see if Path is a file
 */
extern int IsFile(char *	PathName,
		  int		Flags)
{
    int				RetVal = FALSE;
    struct stat			StatBuf;

    if (!PathName)
	return(0);

    if (stat(PathName, &StatBuf) == 0 && S_ISREG(StatBuf.st_mode))
	RetVal = TRUE;

#if defined(SIM_DBG) && defined(FF_SILENCE)
    if (FLAGS_OFF(Flags, FF_SILENCE))
	SImsg(SIM_DBG, "Path <%s> %s",
	      PathName, (RetVal) ? "IsFile" : "NotFile");
#endif

    return(RetVal);
}

/*
 * Test to see if Path is a Directory
 */
extern int IsDir(char *		PathName,
		 int		Flags)
{
    int				RetVal = FALSE;
    struct stat			StatBuf;

    if (!PathName)
	return(0);

    if (stat(PathName, &StatBuf) == 0 && S_ISDIR(StatBuf.st_mode))
	RetVal = TRUE;

#if defined(SIM_DBG) && defined(FF_SILENCE)
    if (FLAGS_OFF(Flags, FF_SILENCE))
	SImsg(SIM_DBG, "Path <%s> %s",
	      PathName, (RetVal) ? "IsDir" : "NotDir");
#endif

    return(RetVal);
}
