/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.11 $
 */

#ifndef __mcbase_h__
#define __mcbase_h__

#if defined(HAVE_AUTOCONFIG_H)
#	include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */

/*
 * MagniComp common definetions
 * 
 * You should almost always include "mconfig.h" directly instead of this file.
 * "mconfig.h" will in turn make sure things like IS_POSIX_SOURCE are defined.
 */
#include "options.h"		/* Need to include options.h before errno.h */
#include "strutil.h"
#include <errno.h>
#include "mctypes.h"
#include "mcconstants.h"
#include "mcmacros.h"
#include "xalloc.h"

/*
 * How to get system error string
 */
#if	defined(SYSERR)
#	undef SYSERR
#endif	/* SYSERR */
#define SYSERR			strerror(errno)

/*
 * FileExists() and Is*() flags
 */
#define FF_SILENCE	0x001		/* No debug output */

/*
 * Declarations go last
 */
#include "mcbase-declare.h"

#endif	/* __mcbase_h__ */
