/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.13 $
 *
 * String utility header
 */

#ifndef __strutil_h__
#define __strutil_h__

#include <stdio.h>
#if HAVE_STRING_H
# include <string.h>
#endif
#if HAVE_STRINGS_H
# include <strings.h>
#endif
#if HAVE_STDLIB_H
# include <stdlib.h>
#endif
#include "mcbase.h"

/*
 * Are flags f set in b?
 */
#ifndef FLAGS_ON
#define FLAGS_ON(b,f)		((b != 0) && (b & f))
#endif
#ifndef FLAGS_OFF
#define FLAGS_OFF(b,f)		((b == 0) || ((b != 0) && !(b & f)))
#endif

/*
 * StrToArgv 
 */
#define STRTO_SKIPRP		0x01		/* Skip repeating sep chars */

/*
 * Declarations
 */
extern int 		StrToArgv(char *, char *, char ***, char *, int);
extern char **		Split(char *, char*);
extern void		DestroyArgv(char ***, int);
extern int		ArgvToStr(char **, char **, int, char *, int);
extern void		strtolower(char *);
extern char *		strlower(char *);
extern char *		strlower2(char *, char *, size_t);
extern char *		strupper(char *);
extern char *		SkipWhiteSpace(char *);
extern char *		Capitalize(char *);
extern char *		StrCat(char *, char *);
extern char *		StrStrip(char *, char *);
extern char *		StrAppend(char *, size_t, char *);
extern int		StrArray(char *, char **);
extern int 		StrArrayAdd(char ***, char *);
extern char *		Join(char *, char **, int);
extern int 		Chop(char *);
extern int		IsQuote(int, char *);
extern char *		FindSep(char *, char *);
extern int		IsSep(int, char *);

#endif	/* __strutil_h__ */
