/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.9 $";
#endif

/*
 * Make directory recursively
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>

/*
 * Do the equiv of "mkdir -p" for Dir
 */
extern int MakeDir(Dir, Mode)
     char		       *Dir;
     mode_t			Mode;
{
    static char			Path[MAXPATHLEN];
    char		       *cp = NULL;
    struct stat			Stat;

    if (!Dir)
	return -1;

    /* Use a disposable buffer */
    snprintf(Path, sizeof(Path), "%s", Dir);

    /* Check everything up to the last component of Path */
    for (cp = Path+1; cp && *cp; ++cp) {
	if (*cp != '/')
	    continue;
	*cp = '\0';
	if (stat(Path, &Stat) != 0)
	    if (mkdir(Path, Mode) != 0)
		return -1;
	*cp = '/';
    }

    /* Do check for the whole of Path now */
    if (stat(Path, &Stat) != 0)
	if (mkdir(Path, Mode) != 0)
	    return -1;

    return 0;
}
