/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.7 $";
#endif

/*
 * Misc
 */
#if defined(HAVE_AUTOCONFIG_H)
# include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */

#include "mcbase.h"
#if HAVE_UNISTD_H
# include <unistd.h>
#endif
#if HAVE_SYS_PARAM_H
# include <sys/param.h>
#endif
#if HAVE_STRING_H
# include <string.h>
#endif

/*
 * Return the directory name portion of Path
 */
extern char *DirName(char *Path)
{
    static char			Buff[MAXPATHLEN];
    char		       *cp;

    if (!Path)
	return (char *) NULL;

    (void) strncpy(Buff, Path, sizeof(Buff));
    if (cp = strrchr(Buff, '/'))
	*cp = CNULL;
    else	/* No slashes */
	return "./";

    return Buff;
}

/*
 * Return the base (file) name portion of Path
 */
extern char *BaseName(char *Path)
{
    char		       *cp;

    if (!Path)
	return (char *) NULL;

    if (cp = strrchr(Path, '/'))
	return cp + 1;

    return Path;
}

/*
 * Get current working directory
 */
extern char *GetCwd(char *Buff, size_t BuffSize)
{
    return getcwd(Buff, BuffSize);
}
