/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.8 $";
#endif

/*
 * Version Info
 */

#if defined(HAVE_AUTOCONFIG_H)
# include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */

#include "mcbase.h"
#include "version.h"
#include "mcsim.h"

/*
 * Print version information
 */
extern void VersionPrint(int	MyTerse,
			 int	MyDebug)
{
    extern char			BuildDate[];
    extern char			BuildHost[];
    extern char			BuildUser[];
    extern char			BuildOSname[];
    extern char			BuildOSver[];
    extern char			BuildOStype[];
    extern char			BuildAppArch[];
    extern char			BuildCPUArch[];
    extern char			BuildCC[];
    extern char			BuildCCver[];
    extern char			BuildCFLAGS[];
    extern char			BuildLIBS[];
    int				MsgFlags = SIM_NONL;

    if (MyDebug)
	MsgFlags |= SIM_DBG;	/* Output to stderr */
    else
	MsgFlags |= SIM_INFO;	/* Output to stdout */

    if (!MyTerse)
	SImsg(MsgFlags, "SysInfo Version ");
    SImsg(MsgFlags, "%s", SYSINFO_VERSION_STR);
    if (SYSINFO_RELEASE || SYSINFO_PATCHLEVEL)
	SImsg(MsgFlags, ".%d", SYSINFO_RELEASE);
    if (SYSINFO_PATCHLEVEL)
	SImsg(MsgFlags, ".%d", SYSINFO_PATCHLEVEL);

    if (MyTerse)
	SImsg(MsgFlags, " %s", SYSINFO_VERSION_STATUS);
    else {
	SImsg(MsgFlags, " (%s)\n", SYSINFO_VERSION_STATUS);
	SImsg(MsgFlags, "Binary Build Information:\n");
#define bOFFSET 18
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "Build Date", BuildDate);
	SImsg(MsgFlags, "  %*s: %s on %s\n", 
	      bOFFSET, "Built By", BuildUser, BuildHost);
	SImsg(MsgFlags, "  %*s: %s %s\n", 
	      bOFFSET, "OS", BuildOSname, BuildOSver);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "OS Type",  BuildOStype);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "App Arch", BuildAppArch);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "CPU Arch", BuildCPUArch);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "Config Dir", CFDIR);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "C Compiler", BuildCC);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "C Compiler Version", 
	      BuildCCver);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "CFLAGS", BuildCFLAGS);
	SImsg(MsgFlags, "  %*s: %s\n", bOFFSET, "Libraries", BuildLIBS);
#undef bOFFSET
	SImsg(MsgFlags, GENERAL_MSG);
	SImsg(MsgFlags, "\n");
	SImsg(MsgFlags, COPYRIGHT_MSG);
    }

    SImsg(MsgFlags, "\n");
}
