/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.7 $";
#endif

#include "defs.h"

/*
 * Get a nice Clock speed string
 */
extern char *GetClockStr(Amt, Unit)
    Large_t			Amt;
    Large_t			Unit;
{
    static char			Buff[64];
    float			a = 0;
    char		       *Qual = NULL;

#if 0
    SImsg(SIM_DBG, "GetClockStr: Amt=%ld Unit=%ld", Amt, Unit);
#endif

    /* We only care about precision for values < 10 */
#define Precision(a)	(((Large_t)a < (Large_t)10) ? 1 : 0)

    Buff[0] = CNULL;

    if (Unit) {
	if (Unit == GHERTZ) {
	    a = (float) Amt;
	    Qual = "GHz";
	} else if (Unit == MHERTZ) {
	    if (Amt > 1000000) {
		a = (float) mhz_to_ghz(Amt);
		Qual = "GHz";
	    } else if (Amt >= 1000) {
		a = (float) mhz_to_ghz(Amt);
		Qual = "GHz";
	    } else {
		a = (float) Amt;
		Qual = "MHz";
	    }
	} else if (Unit == KHERTZ) {
	    if (Amt >= 1000000) {
		a = (float) khz_to_ghz(Amt);
		Qual = "GHz";
	    } else if (Amt >= 1000) {
		a = (float) khz_to_mhz(Amt);
		Qual = "MHz";
	    } else {
		a = (float) Amt;
		Qual = "KHz";
	    }
	}
    }

    if (!a) {
	if (Amt < 1000) {
	    a = (float) Amt;
	    Qual = "Hz";
	} else if (Amt < 1000000) {
	    a = (float) hz_to_khz(Amt);
	    Qual = "KHz";
	} else if (Amt < 1000000000) {
	    a = (float) hz_to_mhz(Amt);
	    Qual = "MHz";
	} else {
	    a = (float) hz_to_ghz(Amt);
	    Qual = "GHz";
	}			    
    }

    if (a && Qual) {
	(void) snprintf(Buff, sizeof(Buff), "%.*f %s",
			Precision(a), a, Qual);
	return(Buff);
    }

    return (char *) NULL;
}
