/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.11 $";
#endif

#include "defs.h"
#include "mcconstants.h"
#include <ctype.h>

/*
 * Get a nicely formated size string for Amt.
 */
extern char *GetSizeStr(Large_t 	Amt,
			Large_t 	Unit,
			int		Flags)
{
    static char			Buff[64];
    float			a;

    /* We only care about precision for values < 10 */
#define Precision(a)	(((Large_t)a < (Large_t)10) ? 1 : 0)

    Buff[0] = CNULL;

    if (Unit) {
	if (Unit == GBYTES) {
	    (void) snprintf(Buff, sizeof(Buff), "%.0f GB", (float) Amt);
	} else if (Unit == MBYTES) {
	    if (Amt >= KBYTES) {
		a = (float) mbytes_to_gbytes(Amt);
		(void) snprintf(Buff, sizeof(Buff), "%.*f GB",
				Precision(a), a);
	    } else {
		(void) snprintf(Buff, sizeof(Buff), "%.*f MB",
				Precision(Amt), (float) Amt);
	    }
	} else if (Unit == KBYTES) {
	    if (Amt >= MBYTES) {
		a = (float) kbytes_to_gbytes(Amt);
		(void) snprintf(Buff, sizeof(Buff), "%.*f GB",
				Precision(a), a);
	    } else if (Amt > KBYTES) {
		a = (float) kbytes_to_mbytes(Amt);
		(void) snprintf(Buff, sizeof(Buff), "%.*f MB",
				Precision(Amt), a);
	    } else {
		(void) snprintf(Buff, sizeof(Buff), "%.*f KB",
				Precision(Amt), (float) Amt);
	    }
	}
    }

    if (Buff[0] == CNULL) {
	if (Amt < KBYTES) {
	    (void) snprintf(Buff, sizeof(Buff), "%.0f Bytes", (float) Amt);
	} else if (Amt < MBYTES) {
	    a = (float) bytes_to_kbytes(Amt);
	    (void) snprintf(Buff, sizeof(Buff), "%.*f KB",
			    Precision(a), a);
	} else if (Amt < GBYTES) {
	    a = (float) bytes_to_mbytes(Amt);
	    (void) snprintf(Buff, sizeof(Buff), "%.*f MB",
			    Precision(a), a);
	} else {
	    a = (float) bytes_to_gbytes(Amt);
	    (void) snprintf(Buff, sizeof(Buff), "%.*f GB",
			    Precision(a), a);
	}	    
    }

    return(Buff);
}

/*
 * Get a nicely formated size string for Amt.
 * XXX We don't yet implment handling of Unit (we assume Bytes).
 */
extern char *GetSizeStrOne(Large_t 	Amt,
			   Large_t 	Unit,
			   int		Flags)
{
    static char			Buff[128];
    static char			AmtStr[128];
    char			Qual[32];

    if (Amt > GBYTES_ONE) {
	(void) snprintf(Qual, sizeof(Qual), "GB");
	(void) snprintf(AmtStr, sizeof(AmtStr), "%.0f",
			(float)(Amt / GBYTES_ONE));
    } else if (Amt > MBYTES_ONE) {
	(void) snprintf(Qual, sizeof(Qual), "MB");
	(void) snprintf(AmtStr, sizeof(AmtStr), "%.0f",
			(float)(Amt / MBYTES_ONE));
    } else if (Amt > KBYTES_ONE) {
	(void) snprintf(Qual, sizeof(Qual), "KB");
	(void) snprintf(AmtStr, sizeof(AmtStr), "%.0f",
			(float)(Amt / KBYTES_ONE));
    } else {
	(void) snprintf(Qual, sizeof(Qual), "Bytes");
	(void) snprintf(AmtStr, sizeof(AmtStr), "%.0f",
			(float)(Amt));
    }

    if (FLAGS_ON(Flags, GSSF_BITS)) {
	if (strlen(Qual) == 2)
	    Qual[1] = tolower(Qual[1]);
    }

    if (FLAGS_OFF(Flags, GSSF_NOQUAL)) {
	(void) snprintf(Buff, sizeof(Buff), "%s %s", AmtStr, Qual);
	return Buff;
    } else {
	return AmtStr;
    }
}
