/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.6 $";
#endif

/*
 * Device Sanitization functions
 */

#include "defs.h"

/*
 * Sanitize DiskDrive
 */
extern int DiskDriveSanitize(DiskDrive)
     DiskDrive_t	       *DiskDrive;
{
    u_long			Cyl = 0;

    if (!DiskDrive)
	return -1;

    if (!DiskDrive->SecSize)
	DiskDrive->SecSize = 512;	/* XXX Default sector size */

    if (!DiskDrive->Size) {
	if (DiskDrive->PhyCyl)
	    Cyl = DiskDrive->PhyCyl;
	else if (DiskDrive->DataCyl)
	    Cyl = DiskDrive->DataCyl;

	DiskDrive->Size = nsect_to_mbytes(Cyl * DiskDrive->Tracks *
					  DiskDrive->Sect, DiskDrive->SecSize);
    }

    return 0;
}

/*
 * Make sure this DevInfo DT_DISKDRIVE looks good
 */
extern int DevDiskDriveSanitize(DevInfo)
     DevInfo_t		       *DevInfo;
{
    DiskDriveData_t	       *DiskData;
    DiskDrive_t		       *Disk = NULL;
    char		       *cp;

    if (!DevInfo)
	return -1;

    if (DiskData = (DiskDriveData_t *) DevInfo->DevSpec) {
	if (DiskData->HWdata)
	    DiskDriveSanitize(DiskData->HWdata);
	if (DiskData->OSdata)
	    DiskDriveSanitize(DiskData->OSdata);

	/*
	 * Set Capacity
	 */
	if (!DevInfo->Capacity) {
	    Disk = (DiskData->HWdata && DiskData->HWdata->Size) ?
		DiskData->HWdata : DiskData->OSdata;
	    if (Disk && Disk->Size)
		if (cp = GetSizeStr((Large_t)Disk->Size, MBYTES, 0))
		    DevInfo->Capacity = strdup(cp);
	}
    }

    return 0;
}
