/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.5 $";
#endif

#include "defs.h"

/*
 * Unit # tracking
 */
typedef struct {
    int				Type;		/* Type # */
    int				Class;		/* Class # */
    char		       *Name;		/* Device name */
    int				Unit;		/* Last assigned unit # */
} UnitTrack_t;

static UnitTrack_t	      **UnitTracks;

/*
 * Assign a new Unit # for Type + Class + Name and return it
 */
extern int UnitAssign(Type, Class, Name)
     int			Type;
     int			Class;
     char		       *Name;
{
    register int		i;
    UnitTrack_t		       *New;
    static int			MaxTracks;

    for (i = 0; UnitTracks && UnitTracks[i] && i < MaxTracks; ++i) {
	if (Type && Class && Name) {
	    if (UnitTracks[i]->Type == Type && UnitTracks[i]->Class == Class &&
		EQ(UnitTracks[i]->Name, Name))
		return UnitTracks[i]->Unit++;
	} else if (Type && Class) {
	    if (UnitTracks[i]->Type == Type && UnitTracks[i]->Class == Class)
		return UnitTracks[i]->Unit++;
	} else if (Type) {
	    if (UnitTracks[i]->Type == Type)
		return UnitTracks[i]->Unit++;
	} else if (Class) {
	    if (UnitTracks[i]->Class == Class)
		return UnitTracks[i]->Unit++;
	} else if (Name) {
	    if (EQ(UnitTracks[i]->Name, Name))
		return UnitTracks[i]->Unit++;
	}
    }

    /* Didn't find an existing entry so create one */
    UnitTracks = (UnitTrack_t **) realloc(UnitTracks, 
					  (i + 2) * sizeof(UnitTrack_t *));
    New = (UnitTrack_t *) xcalloc(1, sizeof(UnitTrack_t));
    New->Type = Type;
    New->Class = Class;
    if (Name)
	New->Name = strdup(Name);
    New->Unit = 0;
    UnitTracks[i] = New;
    UnitTracks[i+1] = NULL;
    ++MaxTracks;

    return New->Unit++;
}
