/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.6 $";
#endif

/*
 * Get CPU Speed
 */

#include "defs.h"

extern int GetCpuSpeed(Query)
     MCSIquery_t	      *Query;
{
    static char			Buf[64];
    CpuInfo_t		       *CpuInfo;
    MCSIquery_t			CpuQuery;

    if (Query->Op == MCSIOP_CREATE) {
	if (!Buf[0]) {
	    memset(&CpuQuery, CNULL, sizeof(CpuQuery));
	    CpuQuery.Op = MCSIOP_CREATE;
	    CpuQuery.Cmd = MCSI_CPUINFO;
	    if (mcSysInfo(&CpuQuery) != 0)
		return -1;
	    CpuInfo = (CpuInfo_t *) CpuQuery.Out;
	    if (!CpuInfo) {
		SImsg(SIM_DBG, "GetCpuSpeed: CpuInfo not found.");
		return -1;
	    }
	    if (!CpuInfo->Speed) {
		SImsg(SIM_DBG, "GetCpuSpeed: CpuInfo contains no Speed.");
		return -1;
	    }
	    (void) snprintf(Buf, sizeof(Buf),  "%s", 
			    GetClockStr(CpuInfo->Speed, (Large_t)MHERTZ));
	}

	if (Buf[0]) {
	    Query->Out = (Opaque_t) strdup(Buf);
	    Query->OutSize = strlen(Buf);
	    return 0;
	}
    } else if (Query->Op == MCSIOP_DESTROY) {
	if (Query->Out && Query->OutSize)
	    (void) free(Query->Out);
	return 0;
    }

    return -1;
}
