/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.4 $
 */

#ifndef __netif_h__
#define __netif_h__ 

#include <stdio.h>
#if defined(HAVE_AUTOCONFIG_H)
# include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */
#include "os.h"

#include <sys/types.h>
#include <sys/socket.h>
#if HAVE_SYS_SOCKIO_H
# include <sys/sockio.h>
#endif	/* HAVE_SYS_SOCKIO_H */
#include <sys/param.h>
#include <sys/errno.h>

#include "defs.h"

#include <netdb.h>		/* Must be towards the last, after defs.h */
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#if HAVE_IN_IFADDR
# include <netinet/in_var.h>
#endif	/* HAVE_IN_IFADDR */
#if HAVE_ARPA_INET_H
# include <arpa/inet.h>
#endif	/* HAVE_ARPA_INET_H */

/*
 * Declarations
 */
extern NetIF_t *	 	NetIfNew(void);
extern Opaque_t			NetIfBuild(NetIF_t **, char **);
extern int			NetIfMCSI(MCSIquery_t *);
extern int			NetIfSetMtu(NetIF_t *, int);
extern int			NetIfFlags(NetIF_t *, unsigned long);
extern NetIfFlag_t *		NetIfFlagCopy(NetIfFlag_t *);
extern AddrFamily_t *		GetAddrFamily(int);
extern int			NetIfSetAddrs(char *, int,
					      struct sockaddr_in *,
					      struct sockaddr_in *,
					      struct sockaddr_in *);

extern void		        SetMacInfo(NetIF_t *);

extern NetIF_t *		GetNetifINET(AddrFamily_t *,
					     struct sockaddr_in *,
					     struct sockaddr_in *,
					     struct sockaddr_in *);
extern NetIF_t *		GetNetifUnknown(AddrFamily_t *,
						struct sockaddr_in *,
						struct sockaddr_in *,
						struct sockaddr_in *);

#endif	/* __netif_h__ */
