/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.10 $
 */
#ifndef __mysysinfo_lib_psi__
#define __mysysinfo_lib_psi__ 

/*
 * Platform Specific Interface
 */

/*
 * Psi Entry type - one per method
 */
typedef struct {
    Opaque_t		       (*Get)();
} PSI_t;

#define PSISWITCH_MAX		13

/*
 * PSI Switch
 */
typedef struct {
    PSI_t 			GetBootTime[PSISWITCH_MAX];
    PSI_t 			GetCpuInfo[PSISWITCH_MAX];
    PSI_t 			GetCpuType[PSISWITCH_MAX];
    PSI_t 			GetAppArch[PSISWITCH_MAX];
    PSI_t 			GetKernArch[PSISWITCH_MAX];
    PSI_t 			GetKernBits[PSISWITCH_MAX];
    PSI_t 			GetKernVer[PSISWITCH_MAX];
    PSI_t 			GetLibcName[PSISWITCH_MAX];
    PSI_t 			GetLibcVer[PSISWITCH_MAX];
    PSI_t 			GetManLong[PSISWITCH_MAX];
    PSI_t 			GetManShort[PSISWITCH_MAX];
    PSI_t 			GetMemory[PSISWITCH_MAX];
    PSI_t 			GetVirtMem[PSISWITCH_MAX];
    PSI_t 			GetModel[PSISWITCH_MAX];
    PSI_t 			GetNumCpu[PSISWITCH_MAX];
    PSI_t 			GetOsDist[PSISWITCH_MAX];
    PSI_t 			GetOsName[PSISWITCH_MAX];
    PSI_t 			GetOsVer[PSISWITCH_MAX];
    PSI_t 			GetRomVer[PSISWITCH_MAX];
    PSI_t 			GetSerial[PSISWITCH_MAX];
    PSI_t 			BuildDevices[PSISWITCH_MAX];
    PSI_t 			BuildSoftware[PSISWITCH_MAX];
    PSI_t 			BuildPartInfo[PSISWITCH_MAX];
    PSI_t 			BuildPrinter[PSISWITCH_MAX];
    PSI_t 			BuildLicense[PSISWITCH_MAX];
    PSI_t 			GetOsDistName[PSISWITCH_MAX];
    PSI_t 			GetOsDistVer[PSISWITCH_MAX];
    PSI_t 			GetOsDistNameSh[PSISWITCH_MAX];
    PSI_t 			GetNumCpuVirt[PSISWITCH_MAX];
    PSI_t 			BuildNetIf[PSISWITCH_MAX];
    PSI_t 			BuildNetwork[PSISWITCH_MAX];
} PsiSwitch_t;

/*
 * Each platform declares their own
 */
extern PsiSwitch_t	        PsiSwitch;

#endif	/* __mysysinfo_lib_psi__ */
