/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * Network DNS functions
 */

#include "defs.h"

#ifndef _PATH_RESOLV_CONF
#define _PATH_RESOLV_CONF	"/etc/resolv.conf"
#endif

/*
 * Set Network_t DNS info in Network
 */
extern int NetworkDns(Network_t *Network)
{
    FILE *		FH;
    static char		Line[1024];
    char *		cp;
    char **		Argv;
    int			Argc;

    McDebug("NetworkDns: Reading %s for DNS info . . .", _PATH_RESOLV_CONF);

    if (!Network)
	return -1;

    FH = fopen(_PATH_RESOLV_CONF, "r");
    if (!FH) {
	McDebug("NetworkDns: %s: Open for read failed: %s",
		_PATH_RESOLV_CONF, SYSERR);
	return -1;
    }

    while (fgets(Line, sizeof(Line), FH)) {
	if (Line[0] == ';' || Line[0] == '#')	/* Skip comment lines */
	    continue;
	if (cp = strchr(Line, '\n'))		/* Zap newline */
	    *cp = CNULL;

	McDebug("NetworkDns: LINE=%s", Line);

	Argc = StrToArgv(Line, " \t", &Argv, NULL, STRTO_SKIPRP);
	if (Argc <= 1)
	    continue;

	/* Look for the keywords we care about */
	if (EQ(Argv[0], "domain") && Argv[1]) {
	    McDebug("NetworkDns:\t Setting Domain=<%s>", PRTS(Argv[1]));
	    Network->DnsDomain = strdup(Argv[1]);
	} else if (EQ(Argv[0], "search") && Argv[1]) {
	    /* Similiar to domain, but watch out for ',' seperated list */
	    if (cp = strchr(Argv[1], ','))
		*cp = CNULL;
	    McDebug("NetworkDns:\t Setting domain=<%s>", PRTS(Argv[1]));
	    Network->DnsDomain = strdup(Argv[1]);
	} else if (EQ(Argv[0], "nameserver") || EQ(Argv[0], "server")) {
	    McDebug("NetworkDns:\t Setting server=<%s>", PRTS(Argv[1]));
	    StrArrayAdd(&(Network->DnsServerIPs), Argv[1]);
	    if (cp = AddrStrToHost(Argv[1]))
		StrArrayAdd(&(Network->DnsServerNames), strdup(cp));
	}
    }

    fclose(FH);

    return 0;
}
