/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.4 $";
#endif

/*
 * Linux mouse functions
 */

#include "defs.h"

/*
 * Onboard mouse devices
 */
static char *MouseDevs[] = {
    "/dev/psmouse", "/dev/psaux", NULL
};

/*
 * Probe a Mouse device
 */
extern DevInfo_t *ProbeMouse(ProbeData)
     ProbeData_t	       *ProbeData;
{
    DevInfo_t		       *DevInfo = NULL;
    static char			Type[512];

    SImsg(SIM_DBG, "%s: ProbeMouse Name=<%s>",
	  ProbeData->DevFile, ProbeData->DevName);

    DevInfo = ProbeData->UseDevInfo;
    if (!DevInfo)
	DevInfo = NewDevInfo(NULL);
    DevInfo->Type = DT_POINTER;
    if (ProbeData->DevName)	
	DevInfo->Name = strdup(ProbeData->DevName);
    if (ProbeData->DevFile)
	DevAddFile(DevInfo, strdup(ProbeData->DevFile));

    DevInfo->Model = strdup("PS/2");

    return DevInfo;
}

/*
 * Detect mouse devices
 */
extern int DetectMouse(DevInfo_t **TreePtr, char **SearchNames)
{
    static ProbeData_t		ProbeData;
    char		      **Path;
    int				fd;
    DevInfo_t		       *DevInfo;

    for (Path = MouseDevs; Path && *Path; ++Path) {
	SImsg(SIM_DBG, "DetectMouse: Checking <%s>", *Path);
	/*
	 * If we can't open the device then it doesn't exist
	 */
	fd = open(*Path, O_RDONLY|O_ACCMODE);
	if (fd < 0) {
	    SImsg(SIM_DBG, "%s: Open for read failed: %s", *Path, SYSERR);
	    continue;
	}
	(void) memset(&ProbeData, CNULL, sizeof(ProbeData));
	ProbeData.DevName = BaseName(*Path);
	ProbeData.DevFile = *Path;
	ProbeData.FileDesc = fd;
	if (DevInfo = ProbeMouse(&ProbeData))
	    AddDevice(DevInfo, TreePtr, SearchNames);
	if (fd)
	    close(fd);
	/* Stop after finding first mouse */
	break;
    }
}
