/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.2 $";
#endif

/*
 * MacOS X CPU functions
 */

#include "defs.h"

/*
 * Probe a CPU
 */
extern int CpuProbe(DevInfo_t *DevInfo)
{
    char *			cp;
    CpuInfo_t *			Cpu;

    if (!DevInfo)
	return -1;

    SImsg(SIM_DBG, "CpuProbe: Device=<%s>",
	  PRTS(DevInfo->Name));

    /*
     * We get what little info we can from sysctl().
     * Unfortunately the IO Registry data is short and vague
     * (it will tell you cache info, but what tell you what cache
     * L1 or L2 the info is for).
     */
    if (DevInfo->DevSpec) {
	Cpu = (CpuInfo_t *) DevInfo->DevSpec;
    } else if (Cpu = GetCpuInfoSysCtl()) {
	DevInfo->DevSpec = (Opaque_t) Cpu;
    } else {
	Cpu = CpuInfoNew(NULL);
	DevInfo->DevSpec = (Opaque_t) Cpu;
    }

    if (!DevInfo->Speed && Cpu->Speed)
	if (cp = GetClockStr(Cpu->Speed, MHERTZ))
	    DevInfo->Speed = strdup(cp);

    return 0;
}
