/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.4 $";
#endif

/*
 * MacOS X framebuffer functions
 */

#include "defs.h"

/*
 * Probe a framebuffer
 * This function must be called after the entire device tree is in
 * place so that we can check for children (Slaves) devices.
 */
extern int FbProbe(DevInfo_t *DevInfo)
{
    char *			cp;
    FrameBuffer_t *		fb;

    if (!DevInfo)
	return -1;

    SImsg(SIM_DBG, "FbProbe: Device=<%s>",
	  PRTS(DevInfo->Name));

    if (DevInfo->DevSpec)
	fb = (FrameBuffer_t *) DevInfo->DevSpec;
    else {
	fb = NewFrameBuffer(NULL);
	DevInfo->DevSpec = (Opaque_t) fb;
    }

    if (cp = DescFind(DevInfo->DescList, "Height"))
	fb->Height = strtol(cp, NULL, 16);
    if (cp = DescFind(DevInfo->DescList, "Width"))
	fb->Width = strtol(cp, NULL, 16);
    if (cp = DescFind(DevInfo->DescList, "Depth"))
	fb->Depth = strtol(cp, NULL, 16);

    if (DevInfo->Slaves) {
	/*
	 * If the first slave has capacity and we don't and the slave
	 * starts with name "display", then make the capacity be on
	 * DevInfo (the framebuffer) where it belongs.
	 */
	if (DevInfo->Slaves->Capacity && !DevInfo->Capacity &&
	    EQN(DevInfo->Slaves->Name, "Display_", 8)) {
	    DevInfo->Capacity = DevInfo->Slaves->Capacity;
	    DevInfo->Slaves->Capacity = NULL;
	}
	/* Set slave device type */
	if (DevInfo->Slaves->Type <= 0) {
	    if (EQN(DevInfo->Slaves->Name, "Display_", 8) ||
		((cp = DescFind(DevInfo->Slaves->DescList,
				"I/O Name Match")) &&
		  EQ(cp, "display"))) {
		DevInfo->Slaves->Type = DT_MONITOR;
	    }
	}
    }

    return 0;
}
