/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.3 $
 */
#ifndef __iok_h__
#define __iok_h__

#include <mach/port.h>
#include <CoreFoundation/CoreFoundation.h>
#include <IOKit/IOCFSerialize.h>
#include <IOKit/IOKitLib.h>

/*
 * Type for passing through IOK functions
 */
typedef struct {
    char		       *Key;		/* Key string */
    char		       *ValStr;		/* String value */
    Large_t		        ValNum;		/* Numeric value */
    int				First;		/* First time called */
    /* SoftInfo specific */
    SoftInfo_t		       *SoftInfo;	/* Software Info entry */
    SoftInfo_t		      **SoftInfoTree;	/* Software Info Tree */
    char		       *Dir;		/* Dir of software */
    /* DevInfo specific */
    DevInfo_t		       *DevInfo;	/* Device Info entry */
    Large_t			VendorID;	/* PCI Vendor ID */
    Large_t			DeviceID;	/* PCI Device ID */
} IOKparam_t;

/*
 * Declarations
 */
extern int IOKvalue(CFTypeRef, IOKparam_t *);
extern void IOKSetProp(const void *, const void *, void *);
extern char *IOKstring(CFStringRef);
extern void IOKdevType(IOKparam_t *);

#endif	/* __iok_h__ */
