/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.8 $
 */

#ifndef __mcsysinfo_macosx_h__
#define __mcsysinfo_macosx_h__

/*
 * Darwin (MacOS X)
 */

#include <fcntl.h>
#include <sys/param.h>
#if defined(HAVE_SYS_SOCKIO_H)
# include <sys/sockio.h>
#endif
#if defined(HAVE_SYS_SOCKET_H)
# include <sys/socket.h>
#endif
#if defined(HAVE_NET_ETHERNET_H)
# include <net/ethernet.h>
#endif

/*
 * What we are
 */
#define SETMACINFO_FUNC		SetMacInfoSysCtl

/*
 * Constants
 */
#define NSWAP_SIZE		8192	/* Size of "nswap" blocks */

/*
 * Create newstyle device names with a slash (/) between name and unit.
 */
#define MKDEVNAME_SLASH

/*
 * Eliminate psuedo intermediate devices
 */
#define ELIMINATE_PSEUDO_INTERMEDIATES

/*
 * Use sysctl(3) to get Network Interface info
 */
#define GETNETIF_TYPE		GETNETIF_SYSCTL

/*
 * Pathnames
 */
#define _PATH_SW_VERS		"/usr/bin/sw_vers"
#define _PATH_MACHINE		"/usr/bin/machine"
#define _PATH_DEV		"/dev"

#endif	/* __mcsysinfo_macosx_h__ */
