/*
 * Copyright (c) 1992-2002 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.1 $";
#endif

/*
 * SunOS 5.x OS Dist functions
 */

#include "defs.h"

/*
 * Get the OS Dist information by reading the first line of /etc/release
 */
extern char *GetOSDistSunOS5()
{
    static char			Buff[256];
    FILE		       *fp;
    register char	       *cp;
    static char		       *Dist;

#if	defined(OS_RELEASE_FILE)
    if (Dist)
	return Dist;

    fp = fopen(OS_RELEASE_FILE, "r");
    if (!fp) {
	SImsg(SIM_GERR, "%s: Cannot open OS release file: %s", 
	      OS_RELEASE_FILE, SYSERR);
	return((char *) NULL);
    }

    if (!fgets(Buff, sizeof(Buff), fp)) {
	SImsg(SIM_GERR, "%s: Read OS release file failed: %s",
	      OS_RELEASE_FILE, SYSERR);
	(void) fclose(fp);
	return((char *) NULL);
    }
    (void) fclose(fp);

    /* Zap trailing newline */
    if (cp = strchr(Buff, '\n')) 
	*cp = CNULL;

    /* Skip leading white space */
    for (cp = Buff; isspace(*cp); ++cp);

    Dist = cp;
#endif	/* OS_RELEASE_FILE */

    return Dist;
}

/*
 * Get the OS Dist Name
 */
extern char *GetOSDistNameSunOS5()
{
    char *			DistStr;
    char *			cp;

    DistStr = GetOSDistSunOS5();
    if (!DistStr) {
	SImsg(SIM_DBG, "GetOSDistNameSunOS5: GetOSDistSunOS5() returned NULL");
	return (char *) NULL;
    }
    
    SImsg(SIM_DBG, "GetOSDistNameSunOS5: Dist=<%s>", DistStr);

    /* Make copy since we need to modify it */
    DistStr = strdup(DistStr);

    if (cp = strchr(DistStr, ' '))
	*cp = CNULL;

    return DistStr;
}

/*
 * Get the OS Dist Version
 */
extern char *GetOSDistVerSunOS5()
{
    char *			DistStr;
    char *			cp;

    DistStr = GetOSDistSunOS5();
    if (!DistStr) {
	SImsg(SIM_DBG, "GetOSDistVerSunOS5: GetOSDistSunOS5() returned NULL");
	return (char *) NULL;
    }
    
    SImsg(SIM_DBG, "GetOSDistVerSunOS5: Dist=<%s>", DistStr);

    /* Make copy since we need to modify it */
    DistStr = strdup(DistStr);

    /*
     * DistStr looks like:
     *	 Solaris 9 s9_58shwpl3 SPARC
     */
    /* Advance past dist name */
    if (cp = strchr(DistStr, ' ')) {
	*cp = CNULL;
	++cp;
	DistStr = cp;
    }
    /* Find end of version and zap */
    if (cp = strchr(DistStr, ' ')) {
	*cp = CNULL;
    }

    return DistStr;
}
