/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.2 $";
#endif

/*
 * DMI function to get the # of CPU's installed in system
 */

#include "defs.h"
#include "dmi.h"

static Dmi_t		       *Dmi;

/*
 * Get # CPUs from DMI
 */
extern Opaque_t DmiGetNumCpu()
{
    static char		       *NumCpuStr;
    int				NumCpu = 0;
    char		       *Data;
    DmiHeader_t		       *Hdr;
    static DmiQuery_t		Query;
    DmiEps_t		       *Eps;
    register int		i;

    if (NumCpuStr)
	return (Opaque_t) NumCpuStr;

    SImsg(SIM_DBG, "DmiGetNumCpu: Searching DMI for # CPUs");

    if (!Dmi)
	Dmi = DmiGet();
    if (!Dmi || !Dmi->Eps) {
	SImsg(SIM_DBG, "DmiGetNumCpu: Cannot find DMI information.");
	return (Opaque_t) NULL;
    }

    Eps = Dmi->Eps;

    Data = DmiGetTable(Dmi);
    if (!Data)
	return (Opaque_t) NULL;

    for (i = 0; i < EPS(Eps, NumStructs); ++i) {
	Hdr = (DmiHeader_t *) Data;

	/*
	 * Check to see if this is a CPU
	 */
	if (Hdr->Type == DMI_STRUCT_PROC) {
	    memset(&Query, CNULL, sizeof(Query));
	    Query.Type = DMI_STRUCT_PROC;
	    if (DmiDecodeProc(Hdr, Data, Dmi, &Query))
		++NumCpu;
	}

	/* Skip to next header */
	Data += Hdr->Length;
	while (*Data || Data[1])
	    Data++;
	Data += 2;
    }

    if (NumCpu > 0)
	NumCpuStr = strdup(itoa(NumCpu));

    SImsg(SIM_DBG, "DmiGetNumCpu: #CPU=%d (%s)", NumCpu, PRTS(NumCpuStr));

    return (Opaque_t) NumCpuStr;
}
