/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef __mckvm_h__
#define __mckvm_h__
/*
 * $Revision: 1.13 $
 */

/*
 * KVM Address type for KVMget().
 * Should always match 2nd argument type for kvm_read(3)
 */
#if 	defined(KVMADDR_T)
typedef KVMADDR_T		KVMaddr_t;
#else
typedef unsigned long		KVMaddr_t;
#endif

#if HAVE_KVM_H
/*
 * Use system kvm.h
 */
# include <kvm.h>
#else	/* !HAVE_KVM_H */
/*
 * Do our own definetions
 */
#define MC_KVM_LIB	1	/* So we can tell what's our own */

struct _kvmd {
    int			kmemd;
    char	       *namelist;
    char	       *vmfile;
};
typedef struct _kvmd kvm_t;

extern kvm_t *	        kvm_open();
extern int		kvm_close();
extern int		kvm_nlist();
extern int		kvm_read();
extern int		kvm_write();

extern char *		kvmerrstr;

#endif	/* HAVE_KVM_H */

#endif /* __mckvm_h__ */
