/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.4 $";
#endif

/*
 * alloc functions
 */
#include <stdio.h>
#include "mcdefs.h"
#include "xalloc.h"

/*
 * Front end to calloc()
 */
extern void *xcalloc(size_t nele, size_t esize)
{
    void 		       *p;

#if	defined(SYSINFO_ALLOC_DEBUG)
    Debug("calloc nele %d size %d", nele, esize);
#endif
    if ((p = (void *) calloc(nele, esize)) == NULL) {
	Fatal(1, "calloc(%d, %d) failed.", nele, esize);
    }

    return(p);
}

extern void *xmalloc(size_t size)
{
    void		       *newptr;

#if	defined(SYSINFO_ALLOC_DEBUG)
    Debug("malloc size %d", size);
#endif
    if (!(newptr = (void *) malloc(size))) {
	Fatal(1, "malloc size %d failed: %s", size, SYSERR);
    }

    return(newptr);
}

extern void *xrealloc(void *ptr, size_t size)
{
    void		       *newptr;

#if	defined(SYSINFO_ALLOC_DEBUG)
    Debug("realloc 0x%x size %d", ptr, size);
#endif
    if (!(newptr = (void *) realloc(ptr, size))) {
	Fatal(1, "realloc 0x%x size %d failed: %s", ptr, size, SYSERR);
    }

    return(newptr);
}
