/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.19 $
 */

/*
 * Declarations for sysinfod
 */
#ifndef __sysinfod_declare_h__
#define __sysinfod_declare_h__

#include "defs.h"
#include "ssp.h"

/*
 * Variables
 */
extern int				MsgClassFlags;
extern int				ForkFlag;
extern char *				ProgName;
extern char *				ProgPath;

/*
 * Functions
 */
extern char *		CFgetValue(char *);
extern char *		CFfileName(char *);
extern int		CFread(char *, char *);
extern int		CFsetEnt();
extern int		CFgetEnt(char **, char **);

extern SSPsession_t *	SSPstart();
extern CmdDispatch_t *	SSPcmdGet();
extern void		SSPclose(SSPsession_t *);
extern int		SSPsessionValid(SSPsession_t *);
extern char *		SSPreadLine(SSPsession_t *);
extern char *		SSPclientStr(SSPsession_t *);

extern int		SSPauth(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPbye(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPnoop(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPsendCmd(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPversion(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPlicense(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPmembers(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPtypes(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPclasslist(SSPsession_t *, char **, int, CmdDispatch_t *);
extern int		SSPsetoption(SSPsession_t *, char **, int, CmdDispatch_t *);

extern char **		SIEclassList();
extern char *		SIEsysinfoPath(char *);
extern char *		SIEversion();
extern int		SIElicense(char ***);
extern int		SIEmembers(char ***);
extern int		SIEtypes(char ***);

extern char *		ServerVersion();

extern CIOhandle_t *	SIEclassSet(char *);
extern char *		SIEclassGet(CIOhandle_t *);
extern int		SIEclassEnd(CIOhandle_t *);

extern char *		SIEoptionStr();
extern int		SIEoptionSet(char *);

extern char **		AuthTypesEnabled(int *);

#endif	/* __sysinfod_declare_h__ */

