/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.2 $";
#endif

/*
 * PID
 */

#include "defs.h"

extern int PidSave()
{
    char *		File = SYSINFOD_PID_FILE;
    char *		Dir = NULL;
    FILE *		FP;
    pid_t		Pid = getpid();

    Dir = DirName(File);
    if (!IsDir(Dir, 0)) {
	Debug("Creating pid directory %s", Dir);
	if (MakeDir(Dir, 0755) != 0) {
	    SImsg(SIM_CERR, "mkdir %s failed: %s", Dir, SYSERR);
	    return -1;
	}
    }

    FP = fopen(File, "w");
    if (!FP) {
	SImsg(SIM_CERR, "open pid file %s for write failed: %s", File, SYSERR);
	return -1;
    }

    Debug("Saving our PID (%d) to %s", Pid, File);

    (void) fprintf(FP, "%d\n", Pid);

    (void) fclose(FP);

    (void) chmod(File, 0644);

    return 0;
}
