/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.7 $";
#endif

/*
 * SysInfo Server
 */

#include "defs.h"
#include <signal.h>
#include <sys/wait.h>

/*
 * Signal Handler to receive any pending child states.
 */
extern void SigReaper(int Sig)
{
    pid_t			Child;
    int				ws;

    Debug("SigReaper: called");

    do {
	Child = wait3(&ws, WNOHANG, (struct rusage *) 0);
	Debug("SigReaper: wait3() returned child pid %d", Child);
    } while (Child > 0);

    (void) signal(SIGCHLD, SigReaper);
}

/*
 * Setup signal handling
 */
extern int SigSetup()
{
#if defined(BSD)
    (void) signal(SIGCHLD, SigReaper);
#else
    (void) signal(SIGCHLD, SIG_IGN);	/* Ignore */
#endif
    (void) signal(SIGALRM, SIG_IGN);	/* Ignore */
    (void) signal(SIGUSR1, SIG_IGN);	/* Ignore */

    return 0;
}
