/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.5 $";
#endif

/*
 * SSP general functions
 */

#include "defs.h"

/*
 * Return easy-to-print client info for logging
 */
extern char *SSPclientStr(SSPsession_t *s)
{
    static char			Buff[512];

    snprintf(Buff, sizeof(Buff), "%s %s port %d",
	     PRTS(s->ClientName), PRTS(s->ClientIP), s->ClientPort);

    return Buff;
}

/*
 * Close down the session
 */
extern void SSPclose(SSPsession_t *s)
{
    SImsg(SIM_INFO, "Closing session %s\n",
	  SSPclientStr(s));

    SSPsend(s, SSP_RC_BYE, SSP_RCC_SINGLE, "Closing session");
    close(s->ReadFD);
    close(s->WriteFD);
    s->ReadFD = s->WriteFD = -1;
    fclose(s->ReadFP);
    fclose(s->WriteFP);
    s->ReadFP = s->WriteFP = NULL;

    exit(0);
}

/*
 * Is session s valid?
 */
extern int SSPsessionValid(SSPsession_t *s)
{
    if (s->ReadFD >= 0 && s->WriteFD >= 0)
	return TRUE;
    else
	return FALSE;
}
