/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.4 $";
#endif

/*
 * SSP read functions
 */

#include "defs.h"

/*
 * Read and return a single line from the client.
 */
extern char *SSPreadLine(SSPsession_t *s)
{
    static char			Line[512];
    char *			cp;

    clearerr(s->ReadFP);	/* Clear pending errors if any */

    if (fgets(Line, sizeof(Line), s->ReadFP)) {
	if (cp = strchr(Line, '\n'))
	    *cp = CNULL;
	if (cp = strchr(Line, '\r'))
	    *cp = CNULL;
	return Line;
    }

    if (ferror(s->ReadFP)) {
	Debug("SSPreadLine: read error - file handle error: %s", SYSERR);
	SSPclose(s);
	return (char *) NULL;
    }
    if (feof(s->ReadFP)) {
	/* The client disconnected without saying BYE */
	Debug("SSPreadLine: read error - at EOF.");
	SSPclose(s);
	return (char *) NULL;
    }

    return (char *) NULL;
}
