/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.6 $";
#endif

/*
 * SSP write functions
 */

#include "defs.h"
#include <unistd.h>

/*
 * Write Buffer to session client
 */
extern int SSPwrite(SSPsession_t *	s,
		    char *		Buffer,
		    size_t		BufLen)
{
    size_t			Total = 0;
    size_t			r;

    if (!s)
	return -1;

    do { 
	r = write(s->WriteFD, Buffer, BufLen);
	if ((long)r < 0) {
	    SImsg(SIM_GERR, "SSPwrite: Write error at byte %d/%d client %s",
		  Total, BufLen, PRTS(s->ClientIP));
	    return -1;
	}
	Total += r;
    } while (Total < BufLen);

    return 0;
}

/*
 * Send one line
 */
extern int SSPsendLine(SSPsession_t *	s,
		       char *		Msg)
{
    if (!s || !Msg)
	return -1;

    SImsg(SIM_DBG|SIM_NONL, "> %s", Msg);

    return SSPwrite(s, Msg, strlen(Msg));
}

#if	ARG_TYPE == ARG_STDARG
#include <stdarg.h>
/*
 * Send a (one line) message to the client.
 */
extern int SSPsend(SSPsession_t *	s,
		   char *		ResponseCode,
		   char			ResponseType,
		   char *		Fmt,
		   			...)
{
    static char				Buff[8192];
    int					l;
    va_list				Args;

    if (!s || !ResponseCode || !ResponseType)
	return -1;

    snprintf(Buff, sizeof(Buff), "*%c%s%s",
	     ResponseType, ResponseCode, (Fmt) ? " " : "");
    l = strlen(Buff);

    if (Fmt) {
	va_start(Args, Fmt);
	vsnprintf(&Buff[l], sizeof(Buff)-l, Fmt, Args);
	va_end(Args);
    }

    /*
     * Add a newline
     */
    l = strlen(Buff);
    snprintf(&Buff[l], sizeof(Buff)-l, "\n");

    return SSPsendLine(s, Buff);
}
#endif	/* ARG_STDARG */
