/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

/*
 * Setup Ask functions
 */

#include "defs.h"

char			       *AnswersYN[3] = { A_YES, A_NO, NULL };

/*
 * Ask a question
 */
extern char *Ask(char *		Question,
		 char **	AnswerList,
		 char *		Default,
		 char *		HelpMsg,
		 int		Flags)
{
    char			Prompt[512];
    char		       *Ans = NULL;
    size_t			Len;
    char		      **cpp;
    int				i;

    if (!Question)
	return (char *) NULL;

    snprintf(Prompt, sizeof(Prompt), "%s ", Question);
    Len = strlen(Prompt);

    if (AnswerList) {
	snprintf(&Prompt[Len], sizeof(Prompt)-Len, "(");
	Len = strlen(Prompt);
    }
	
    for (cpp = AnswerList; cpp && *cpp; ++cpp) {
	if (cpp != AnswerList) {
	    snprintf(&Prompt[Len], sizeof(Prompt)-Len, ",");
	    ++Len;
	}
	snprintf(&Prompt[Len], sizeof(Prompt)-Len, "%s", *cpp);
	Len = strlen(Prompt);
    }

    if (AnswerList) {
	snprintf(&Prompt[Len], sizeof(Prompt)-Len, ") ");
	Len = strlen(Prompt);
    } else {
	snprintf(&Prompt[Len], sizeof(Prompt)-Len, " ");
	Len = strlen(Prompt);
    }

    if (Default) {
	snprintf(&Prompt[Len], sizeof(Prompt)-Len, "[%s] ", Default);
	Len = strlen(Prompt);
    }

    for (i = 0; i < SETUP_MAX_PROMPTS; ++i) {
	if (HelpMsg)
	    Msg(0, "%s\n", HelpMsg);

	Msg(0, "%s", Prompt);

	if (ConfirmFlag && Default) {
	    Ans = Default;
	    Msg(0, "%s\n", Ans);
	    return Ans;
	}

	Ans = GetInput(0);
	Len = strlen(Ans);
	if (Default && Len == 0)
	    return Default;
	if (Len == 0)
	    continue;

	if (!AnswerList)
	    return Ans;

	for (cpp = AnswerList; cpp && *cpp; ++cpp)
	    if (EQ(Ans, *cpp))
		return Ans;

	/* If AF_NUMLIST is on and the answer starts with a digit, return it */
	if (FLAGS_ON(Flags, AF_NUMLIST))
	    if (isdigit(*Ans))
		return Ans;

	Msg(0, "The input \"%s\" is not valid.\n", Ans);
    }

    Error("Maximum prompt limit reached.");
    return (char *) NULL;
}

