/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.23 $
 */

#ifndef __setup_h__
#define __setup_h__ 

#if	defined(HAVE_AUTOCONFIG_H)
#include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */
#if	defined(HAVE_STDLIB_H)
#include <stdlib.h>
#endif
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>
#include "mcsysinfo.h"
#include "mcbase.h"
#include "mctypes.h"
#include "mcdefs.h"
/*#include "mcmacros.h"*/
#undef   Debug
#include "mcdmap.h"
#include "mcdpackage.h"
#include "mcdproduct.h"

#define METERNUM_T Large_t
#include "meter.h"

/*
 * Macros
 */
#ifndef EQ
#define EQ(a,b)			(strcasecmp(a,b) == 0)
#endif
#ifndef EQN
#define EQN(a,b,n)		(strncasecmp(a,b,n) == 0)
#endif
#define CNULL			'\0'
#ifndef TRUE
#define TRUE			1
#endif
#ifndef FALSE
#define FALSE			0
#endif
#ifndef PRTS
#define PRTS(s)			( ( s && *(s) ) ? s : "" )
#endif
/*
 * Are flags f set in b?
 */
#ifndef FLAGS_ON
#define FLAGS_ON(b,f)		((b != 0) && (b & f))
#endif
#ifndef FLAGS_OFF
#define FLAGS_OFF(b,f)		((b == 0) || ((b != 0) && !(b & f)))
#endif
/*
 * Undo main Debug macro
 */
#undef Debug

/*
 * Special file names/paths
 */
#define FN_FINISH		"finish.msg"	/* Finish message file */
#define FN_MCD			"mcd"		/* mcd data directory */
#define FN_MCDMAP_FILE		"mcdmap"	/* mcdmap file extension */
#define FN_MCDPKG_FILE		"mcdpkg"	/* mcdpkg file name */
#define FN_PACKAGES_DIR		"packages"	/* Packages dir */
#define FN_FILES_DIR		"files"		/* Directory containing files*/
#define FN_MCDPOST		"mcdpost" 	/* Post {un}install script */
#define FN_MCDPRODUCT		"mcdproduct"	/* Product info file */

/*
 * Answers
 */
#define A_YES			"Yes"
#define A_NO			"No"
#define A_ACCEPT		"Accept"
#define A_DECLINE		"Decline"
#define A_ALL			"All"
#define A_NONE			"None"
#define A_SELECTED		"Selected"

/*
 * Ask Flags
 */
#define AF_NUMLIST		0x01		/* Get list of numbers */

/*
 * Misc
 */
#define SETUP_MAX_PROMPTS	10		/* Max times to ask user */
#undef  COPYRIGHT_MSG
#define COPYRIGHT_MSG		"Copyright (c) 2000-2003 MagniComp"

/*
 * How to get system error string
 */
#if	defined(SYSERR)
#	undef SYSERR
#endif	/* SYSERR */
extern		int 			errno;
#define		SYSERR			strerror(errno)

/*
 * Msg() flags
 */
#define MSGF_NOLOG		0x01		/* Do not log to a file */
#define MSGF_FILE		0x02		/* Arg is a file to display */

/*
 * Line types
 */
#define LT_SINGLE		'-'		/* Single line width */
#define LT_DOUBLE		'='		/* Double line width */

/*
 * Overall data type
 */
typedef struct {
    McdMap_t *			MapData;	/* All data from the mcdmap */
    McdProduct_t *		Products;	/* All Products found */
    char *			InstallDir;	/* Installation dir */
    char *			DistDir;	/* Distribution dir */
    char *			ProgramPath;	/* Path to invoked program */
    char *			ProgramName;	/* Base name of ProgramPath */
    char **			PkgList;	/* List of pkgs to op on */
} McdData_t;

/*
 * Declarations come after all types are defined
 */
#include "setup-declare.h"

#endif	/* __setup_h__ */
