/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.9 $
 */

#ifndef __mcdmap_h__
#define __mcdmap_h__ 

#include <sys/types.h>

#define MCDMAP			"mcdmap"

/*
 * MCD Map entry
 */
struct _McdMap {
    int				Type;		/* File type */
    char		       *Package;	/* Package name */
    char		       *Src;		/* Path name of src file */
    char		       *Dest;		/* Destination path */
    char		       *Owner;		/* Owner name */
    char		       *Group;		/* Group owner */
    off_t			Size;		/* File size (bytes) */
    mode_t			Mode;		/* File mode */
    int				Flags;		/* Flags */
    struct _McdMap	       *Next;		/* Next entry in list */
};
typedef struct _McdMap McdMap_t;

/*
 * Values of McdMap_t.Type
 */
#define MCDT_FILE		1		/* Regular file */
#define MCDT_DIR		2		/* Directory */
#define MCDT_SYMLINK		3		/* Symbolic link */

/*
 * Values for McdMap_t.Flags
 */
#define MCDF_EDIT		0x01		/* Need to edit on install */

#endif	/* __mcdmap_h__ */
