/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.4 $
 */

#ifndef __mcdpackage_h__
#define __mcdpackage_h__ 

#if defined(HAVE_AUTOCONFIG_H)
# include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */
#include "mcdmap.h"

/*
 * Type for a package
 */
struct _McdPackage_t {
    int				Number;		/* Our number for this pkg */
    char *			Name;		/* Name of package */
    char *			Summary;	/* Summary of package */
    char *			PostInstall;	/* Post install program */
    char *			PostRemove;	/* Post remove program */
    int				Installed;	/* Is pkg installed? */
    int				Required;	/* Boolean: Package required */
    int				Selected;	/* Do something with this pkg*/
    Large_t			Size;		/* Disk space (bytes) */
    McdMap_t *			MapList;	/* List of install entries */
    McdMap_t *			MapListLast;	/* Last entry in MapList */
    struct _McdPackage_t *	Next;
};
typedef struct _McdPackage_t	McdPackage_t;

#endif	/* __mcdpackage_h__ */
