/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.4 $
 */

#ifndef __mcdproduct_h__
#define __mcdproduct_h__ 

#if defined(HAVE_AUTOCONFIG_H)
# include "mcsysinfo-autoconfig.h"
#endif	/* HAVE_AUTOCONFIG_H */
#include <sys/types.h>
#include "mctypes.h"
#include "mcdpackage.h"

/*
 * MCD Product
 */
struct _McdProduct_t {
    char		       *Name;		/* Name of software */
    char		       *Version;	/* Version of software */
    char		       *Release;	/* Release of software */
    char		       *VendorName;	/* Vendor's name */
    char		       *URL;		/* URL of software */
    char		       *Summary;	/* Summary description */
    time_t			DistBuilt;	/* Distribution build time */
    Large_t			Size;		/* Size of dist (bytes) */
    char		       *OSname;		/* Req OS name */
    char		       *OSver;		/* Req OS version */
    char		       *OSverMin;	/* Minimum Req OS version */
    char		       *OSverMax;	/* Maximum Req OS version */
    char		       *Arch;		/* Req architecture */
    char		       *LibCname;	/* Req libc name */
    char		       *LibCverMin; 	/* Min libc version */
    char		       *LicFile;	/* License File */
    int				AskForLic;	/* Ask for License accept */
    char		       *InstallDir;	/* Installation dir */
    char		       *InstallLic;	/* Where to install lic file */
    char		      **PkgList;	/* List of package names */
    char *			ProductFile;	/* MCD product file */
    int				Selected;	/* Is this product selected? */
    int				Required;	/* Product is required? */
    int				Number;		/* Product # for selection */
    McdPackage_t *		Packages;	/* List of package data */
    struct _McdProduct_t *	Next;		/* Next product */
};
typedef struct _McdProduct_t	McdProduct_t;

#endif	/* __mcdproduct_h__ */
