/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.9 $";
#endif

/*
 * Meter functions
 */

#include <stdio.h>
#include "defs.h"		/* Set METERNUM_T to Large_t */
#include "meter.h"

static char		        SpinChars[] = "|/-\\";

/*
 * Backspace
 */
extern void BackSpace(size_t Count)
{
    register int		i;

    for (i = 0; i < Count; ++i)
	Msg(0, "\b");
}

/*
 * Show nice progress meter
 */
extern int Meter(Meter_t *MeterInfo)
{
    int				BarWidth;
    register int		i;
    int				SpinCharsTotal = strlen(SpinChars);
    int				FirstSpin = 1;
    static int			LastWidth;
    static Meter_t	       *LastMeterInfo;
    Meter_t		       *m = MeterInfo;

    if (!m->Total)
	return -1;

    /* Validate Last values */
    if (LastMeterInfo && LastMeterInfo != MeterInfo)
	LastWidth = 0;

    if (LastWidth)
	BackSpace((size_t)LastWidth);

    if (m->Prompt) {
	if (!m->_PromptLen)
	    m->_PromptLen = strlen(m->Prompt);
	BackSpace(m->_PromptLen);
	Msg(0, "%s", m->Prompt);
    }

    /* Determine width of bar */
    if (!m->TermWidth)
	m->TermWidth = 80;
    BarWidth = m->TermWidth - m->_PromptLen - 8;

    Msg(0, "[");
    for (i = 0; i < BarWidth; ++i) {
	if (((float)i/(float)BarWidth) < ((float)m->Current/(float)m->Total))
	    Msg(0, "%c", METER_BAR_CHAR);
	else if (FirstSpin) {
	    if (m->_Spin >= SpinCharsTotal)
		m->_Spin = 0;
	    Msg(0, "%c", SpinChars[m->_Spin++]);
	    FirstSpin = 0;
	} else {
	    Msg(0, " ");
	}
    }
    Msg(0, "] %3.0f%%", ((float)m->Current/(float)m->Total) * (float)100);

    /* Save for next call */
    LastWidth = m->_PromptLen + BarWidth;
    LastMeterInfo = MeterInfo;

    return 0;
}

/*
 * End Meter
 */
extern void MeterEnd(Meter_t *MeterInfo)
{
    if (!MeterInfo)
	return;

    MeterInfo->Current = 0;
}
