/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.6 $";
#endif

/*
 * Setup misc
 */

#include "defs.h"

/*
 * Return path to the File
 */
extern char *McdPath(McdProduct_t *	Product,
		     McdPackage_t *	Package,
		     char *		TopDir,
		     char *		File)
{
    static char			Path[MAXPATHLEN];

    if (!TopDir || !Product || !Product->Name)
	return (char *) NULL;

    if (File && Package)
	snprintf(Path, sizeof(Path), "%s/%s/%s/%s/%s/%s",
		 TopDir,
		 FN_MCD,
		 Product->Name,
		 FN_PACKAGES_DIR,
		 Package->Name,
		 File);
    else if (File)
	snprintf(Path, sizeof(Path), "%s/%s/%s/%s",
		 TopDir,
		 FN_MCD,
		 Product->Name,
		 File);
    else
	snprintf(Path, sizeof(Path), "%s/%s/%s",
		 TopDir,
		 FN_MCD,
		 Product->Name);

    return Path;
}

/*
 * Display a line of Type
 */
extern void Line(int Type)
{
    int				i;

    for (i = 0; i < TermWidth-1; ++i)
	Msg(0, "%c", Type);

    Msg(0, "\n");
}

/*
 * Center a line
 */
extern char *Center(char *Msg)
{
    int				i;
    size_t			Len;
    static char			Buff[1024];

    Len = strlen(Msg);
    i = (TermWidth - Len) / 2;
    memset(Buff, ' ', sizeof(Buff));
    snprintf(&Buff[i], sizeof(Buff)-i, "%s", Msg);
    Buff[i + Len] = CNULL;

    return Buff;
}

/*
 * Remove quotes
 */
extern char *DeQuote(char *String)
{
    char		       *New;
    char		       *cp;

    for (cp = String; cp && *cp && (*cp == ' ' || *cp == '"'); ++cp);
    New = cp;

    for (cp = &New[strlen(New)-1]; cp && *cp && (*cp == ' ' || *cp == '"'); 
	 --cp);
    if (cp)
	*(cp+1) = CNULL;

    return New;
}
