/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.23 $
 */

#ifndef __declare_h__
#define __declare_h__ 

#include "mcdmap.h"
#include "mcdproduct.h"

/*
 * Declarations
 */
extern char		       *AnswersYN[];
extern char		       *ProgramName;
extern char *			ProgramPath;

extern int			DebugFlag;
extern int			ConfirmFlag;
extern int			OverRide;
extern int			TermWidth;

extern char		       *GetInput();
extern char		       *GetSysInfo();
extern char		       *BaseName();
extern char		       *DirName();
extern char		       *GetMcdFile();

extern char *		Center(char *);
extern void		Error(char *fmt, ...);
extern void		SetupDebug(char *fmt, ...);
extern void		Msg(int MsgFlags, char *fmt, ...);
extern void		Line(int);

extern void 		ShowSummaryLine(char *, char *);
extern void 		ShowSummary(McdProduct_t *, int, int);
extern void 		ShowSummaryAll(McdData_t *, int);
extern void 		ShowSummaryPkgs(McdPackage_t *, McdProduct_t *,
					int, int);
extern void 		SummaryProductList(McdProduct_t *, int, int);

extern char *		DeQuote(char *);
extern char *		GetDistPath(char *, char *, McdProduct_t *, McdPackage_t *);
extern char *		Ask(char *, char **, char *, char *, int);

extern McdMap_t *	McdNew(void);
extern McdPackage_t *	McdPkgFind(McdPackage_t *, char *);
extern int 		McdPkgAdd(McdPackage_t *, int, char *, char *, mode_t);
extern int 		McdPkgPadding(McdPackage_t *);
extern int 		McdPkgRead(McdData_t *);
extern int 		McdPkgSelectSet(McdProduct_t *, McdData_t *,
					int, char *, int);
extern int 		McdMapRead(McdData_t *);
extern int		McdPkgSelectInstalled(McdData_t *);
extern int		McdPkgUpdate(McdProduct_t *, McdData_t *);
extern void		McdMapDump(McdMap_t *);
extern char *		McdPath(McdProduct_t *, McdPackage_t *, char *, char *);
extern int		McdPost(McdProduct_t *, int);
extern int 		Install(McdData_t *);
extern int 		InstallFiles(McdProduct_t *, char *);
extern int 		UnInstall(McdData_t *);
extern int 		Verify(McdData_t *);
extern int 		LicenseAccept(McdProduct_t *, McdData_t *);
extern int 		Inventory(McdData_t *);
extern int 		InventoryProduct(McdProduct_t *, McdData_t *);
extern int 		InstallLicense(McdProduct_t *);
extern int 		InstallLicenses(McdData_t *);
extern void		Line(int);
extern McdProduct_t *	McdProductRead(char *);
extern int 		McdMapAdd(McdPackage_t *, int, char *, char *, mode_t);
extern int 		SetInstallDir(McdData_t *);

#endif	/* __declare_h__ */
