/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/5.0/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.17 $";
#endif

/*
 * Reporting
 */
#include "defs.h"

char			       *RepSep = " | ";

/*
 * Write out a report format entry
 */
extern void Report(char *	ClassType,
		   char *	InfoType,
		   char *	Key,
		   char **	Data,
		   int		NumData)
{
    register int		i;

    if (!ClassType)
	return;

    SImsg(SIM_INFO, "%s%s%s%s%s", 
	   strlower(ClassType), RepSep, PRTS(InfoType), RepSep, PRTS(Key));

    for (i = 0; i < NumData; ++i) {
	SImsg(SIM_INFO, "%s", RepSep);
	if (Data[i])
	    SImsg(SIM_INFO, "%s", Data[i]);
    }

    SImsg(SIM_INFO, "\n");
}

/*
 * Write out a report format entry for a property item.
 */
extern void ReportProp(char *	Class,
		       char *	Name,
		       char *	Key,
		       char *	Desc,
		       char *	Value)
{
    static char		       *RptData[3];
    int				i = 0;

    if (!Key || !Name || !Value)
	return;

    (void) memset(RptData, CNULL, sizeof(RptData));

    RptData[i++] = PRTS(Key);
    RptData[i++] = PRTS(Desc);
    RptData[i++] = PRTS(Value);

    Report(Class, R_PROP, PRTS(Name), RptData,
	   sizeof(RptData) / sizeof(char *));
}

/*
 * Write out a report format entry for a member
 */
extern void ReportMember(char *	Class,
			 char *	Key,
			 char *	Desc)
{
    static char		       *RptData[1];
    int				i = 0;

    if (!Key)
	return;

    (void) memset(RptData, CNULL, sizeof(RptData));

    RptData[i++] = PRTS(Desc);

    Report(Class, R_MEMBER, Key, RptData, sizeof(RptData) / sizeof(char *));
}

/*
 * Write out a report format entry for a Type
 */
extern void ReportType(char *	Name,
		       char *	Desc)
{
    if (!Name)
	return;

    SImsg(SIM_INFO, "%s%s%s%s%s\n", 
	  R_TYPE, RepSep, PRTS(Name), RepSep, PRTS(Desc));
}

